'    (sous licence GPL version 2)
'programme pour piloter un analyseur de reseau.Il se compose de 2 generateurs a
'synthese directe DDS (AD9851) avec une frequence d'horloge de 150MHz
'l'ecart entre les 2 generateurs est maintenu a 25.006011Hz ,proche de 25Hz dans
'l'espoir d'avoir une rejection du 50Hz et de ses harmoniques
'deux mixers identiques MC1496 recueillent deux signaux a  25Hz
'2 convertisseurs ADC sigma delta 24bits envoient les mesures sur le port USB
'le transfert sur le port USB utilise un microcontrolleur ATmega168 et un
'convertisseur port serie/ port USB (le circuit FT232R de FTDI)

'windowtitle "anareso"
screen 20,8,3'
'screenres 1024,800,24,2 
dim shared time1 as double
dim shared time2 as double
dim shared time3 as double
dim shared time4 as double
dim shared time5 as double
dim shared time6 as double
dim shared usberror as integer=0
dim shared duree as double
dim shared x as integer
dim shared xx as integer
dim shared y as integer
dim shared l as string 'pour la lecture clavier
'dim shared uu as integer=27 '(uu+1)=nombre d'echantillons utilises pour la mesure (apres stabilisation)
dim shared abort as integer=0
dim shared aw as string
dim shared fdd as double=0
dim shared lu as integer=0
dim shared z1 as integer=0
dim shared z2 as integer=0
dim shared z3 as integer=0
dim shared z4 as integer=0
dim shared z5 as integer=0
dim shared z6 as integer=0
dim shared z7 as integer=0
dim shared z8 as integer=0
dim shared z9 as integer=0
dim shared z10 as integer=0
dim shared z11 as integer=0
dim shared z12 as integer=0
dim shared z13 as integer=0
dim shared z14 as integer=0
dim shared z15 as integer=0
dim shared z16 as integer=0
dim shared z17 as integer=0
dim shared z18 as integer=0
dim shared z22 as integer=0
dim shared z23 as integer=0
dim shared z24 as integer=0
dim shared z25 as integer=0
dim shared largeur as double=800 'choisir un nombre qui se divise par (nb-1)
dim shared hauteur as double=690 'choisir un nombre qui se divise par 10
dim shared bor as integer=3
dim shared couleur as integer
dim shared c15 as integer :c15=&hfce4b8 
dim shared c14 as integer :c14=&hfcfc54
dim shared c13 as integer :c13=&hfc54fc
dim shared c12 as integer :c12=&hfc5454
dim shared c10 as integer :c10=&h54fc54
dim shared c9 as integer  :c9=&h707070 
dim shared c3 as integer :c3=&h00a8a8
dim shared c1 as integer :c1=&h909000 
dim shared c2 as integer :c2=&h00a800
dim shared c0 as integer :c0=&h000000
dim shared c6 as integer :c6=&ha85400 
dim shared c7 as integer :c7=&h004c4c
dim shared c8 as integer :c8=&h545454
dim shared cursor1 as integer =100  'peut varier de 0 a largeur(800)
dim shared cursor2 as integer =200  'idem
dim shared cur1 as integer =0
dim shared cur2 as integer =0
dim shared curseur1 as integer  'peut varier de 0 a nb-1
dim shared curseur2 as integer  'idem
dim shared tupeu as integer
dim shared bouton as integer
dim shared wheel as integer=0
dim shared cleft as integer=0
dim shared cright as integer=0
setmouse 1,1,1
dim shared x1 as integer
dim shared y1 as integer
dim shared za as integer
dim shared pi as double =3.1415926
dim shared angle as double =0
dim shared wc1 as double
dim shared zc1 as double
dim shared fstart as double =200
dim shared fstop as double =60000000
dim shared center as double=30000100 'frequence centrale
dim shared span as double=59999800   'etendue du balayage
dim shared linlog as integer=1
dim shared compteur as integer=0
dim shared fago as integer=1 'pour reperer le premier passage dans la boucle d'aquisition
dim shared f as integer
dim shared plouf as ubyte
dim shared p as short =0
dim shared pp as short =0
dim shared freq(805) as double 'tableau des frequences de mesure
'dim shared nb as short =401
dim shared nb as short =401
dim shared li(60) as ubyte
dim shared N1 as uinteger
dim shared N2 as uinteger
dim shared va as byte =1
dim shared i as integer=0
dim shared k as integer
dim shared flag1 as ubyte
dim shared flag2 as ubyte
dim shared bid as ubyte
dim shared t as integer
dim shared M(930) as integer
dim shared Q(930) as integer
dim shared fx as ubyte
dim shared za1 as double
dim shared za2 as double
dim shared za3 as double
dim shared wa1 as double
dim shared wa2 as double
dim shared wa3 as double
dim shared wa6 as double
dim shared za6 as double
dim shared dfi as double
dim shared w33(803) as double 'tableau de mesure de la fonction de transfert
dim shared z33(803) as double
dim shared a1(803) as double 'tableau du module des gains
dim shared t1(803) as double 'tableau des phases ou delay
dim shared aa(803) as double 'tableau des gains pour la memoire(apres calcul sur m1 et m2
dim shared tt(803) as double 'tableau des phases(delay) pour la memoire
dim shared M1(803) as double 'copie des courbes en memoire
dim shared M2(803) as double
dim shared Ma1 as double
dim shared Ma2 as double
dim shared zt(803) as double 'tableau pour la normalization
dim shared wt(803) as double
dim shared M1L(803) as double 'copie des courbes en memoire avec la correction de longueur
dim shared M2L(803) as double
dim shared z3L(803) as double 'fonction de transfert avec correction de longeur
dim shared w3L(803) as double 
dim shared wnd(803) as double 'fonction de transfert avec correction de calibration
dim shared znd(803) as double
dim shared wndd(803) as double 'fonction de transfert de la memoire avec correction de calibration
dim shared zndd(803) as double
dim shared wed3 as double
dim shared zed3 as double
dim shared ha(803) as double
dim shared hb(803) as double
dim shared ti as integer =0
dim shared ga as single
dim shared ma as single
dim shared gaa as single
dim shared maa as single
dim shared maax(5) as double 
dim shared miin(5) as double  'valeur des minimun suivant le mode ti (parametre affiche 1)
dim shared maxa(5) as double  'valeur des maximun suivant le mode ti (parametre affiche 2)
dim shared mina(5) as double 
dim shared oaf as single 
dim shared oaf2 as single
dim shared oap as single
dim shared oap2 as single
dim shared oaa as single
dim shared oaa2 as single
dim shared ouf as single
dim shared ouf2 as single
dim shared oup as single
dim shared oup2 as single
dim shared pmax as integer=0
dim shared limite as integer=0
dim shared stab as integer=7 'temps de stabilisation du filtre analogique (mesur en echantillon)
dim shared nbsamp as integer=6 '(nbsamp+1)=nombre d'echantillons utilises pour la mesure apres stabilisation
dim shared complet as integer=0 'complet=1 a la fin d'une aquisition
dim shared cente as integer=0 'cente=1 quand on rentre la frequence avec center et span
dim shared disp as integer=0 'si disp=1 on est en mode affichage sans balayage
dim shared sort as integer=0 'pour dire qu'il faut sortir
dim shared ef as integer=0 'si ef=1 il faut effacer l'ecran
dim shared copynom as string
copynom="noname"
dim shared cal as integer=0 '1=en attente de enter pour demarrer la calibration
                            '2=en cours de calibration
                            '3=calibration terminee
                            '4=warning, la calibration n'est plus valable
dim shared newcal as integer=0 'newcal=1 indique qu'il faut refaire la calibration
dim shared m1m2 as integer=0 'm1m2=1 indique qu'il y a des donnees valide en memoire
dim shared ap as integer=2 'aperture pour le group delay
dim shared pa as integer=0 'pour avoir une copie de ap
dim shared refresh as integer=0
dim shared titre as string
titre="               Title                    "
dim shared rep as integer
dim shared repl as integer
dim shared lon as double=0 'longueur en metres pour la correction de longueur
dim shared dis as integer=0 'pour choisir les courbes a afficher
dim shared ali as integer=3
dim shared bobo as string
dim shared ff as integer
dim shared gggain as single=1
dim shared ggain as single=1
dim shared ppphas as single=0
dim shared pphas as single=0
dim shared ccclock as integer=150000000
dim shared cclock as integer=150000000
dim shared defogain as single=1 'gain par defaut entre l'entree A et l'entree R
dim shared defophas as single=0 'dephasage par defaut entre l'entree A et l'entree R
dim shared defoclk as integer=150000000 'frequence de l'horloge (par defaut) en Hz
dim shared defousbcom as short=3    'adresse par defaut pour le port COM (USB)
dim shared comport as short=3   'adresse du port COM (USB)
dim shared deforef as single=50 'resistance de calibration, par defaut
dim shared defolref as single=0 'self en serie avec la resistance de calibration
dim shared defocref as single=0 'capa en parallele avec la resistance de calibration
dim shared acquii as integer=0
dim shared zz1 as integer=0
dim shared zz2 as integer=0
dim shared zz3 as integer=0
dim shared zz4 as integer=0
dim shared zz5 as integer=0
dim shared zz6 as integer=0
dim shared zz7 as integer=0
dim shared zz as integer=0
dim shared num as integer=0
dim shared erreur1 as integer=0
dim shared erreur2 as integer=0
dim shared erreur3 as integer=0
dim shared erreur4 as integer=0
dim shared erreur5 as integer=0
dim shared zzz5 as integer=0
dim shared round as single=0
dim shared stoprequest as integer=0
dim shared zq22 as integer=0
dim shared sauvpo as integer
dim shared choi as integer
dim shared bmpecri as integer
dim shared xistdja as string
dim shared ss2112 as integer=0 'ss2112=0 pour dire que c'est s21 que l'on va ecrire
dim shared mxxx as string
dim shared dxxx as string
dim shared axx as single
dim shared t1xx as single
dim shared bibi as string
dim shared taille as integer
dim shared baba as string
dim shared kk as string
kk=""
dim shared c as string*1
dim shared esclam as integer
dim shared diese as integer
dim shared done as integer
dim shared acqi as integer
dim shared ll as integer
dim shared frec as double
dim shared nbb as integer
dim shared freqq as string
dim shared ms11 as string
dim shared as11 as string
dim shared zute1 as double
dim shared zute2 as double
dim shared time9 as double
dim shared fff as integer
dim shared ff2 as integer
dim shared copinom as string
dim shared startorder as string
dim shared received as string
dim shared ressu as string
dim shared relax as integer
dim shared freqecri as string
dim shared freqstring as string
dim shared ii as integer
dim shared zut3 as double
dim shared zut4 as double
dim shared roue as integer
dim shared rouee as integer
dim shared roue1 as integer
dim shared roue2 as integer
dim shared roue3 as integer
dim shared roue4 as integer
dim shared roue5 as integer
dim shared roue6 as integer
dim shared roue7 as integer
dim shared roue8 as integer
dim shared roue9 as integer
dim shared roue12 as integer
dim shared roue14 as integer
dim shared kz as double
dim shared fb as integer
dim shared pixel as ubyte
dim shared ligne as string
dim shared unbyte as ubyte
dim shared deuxbyte as ushort
dim shared quatrebyte as uinteger
dim shared red as ubyte
dim shared green as ubyte
dim shared blue as ubyte
dim shared zero as ubyte
dim shared rouge as uinteger
dim shared vert as uinteger
dim shared bleu as uinteger
dim shared zw1 as ubyte=&h00
dim shared zw2 as ubyte=&h90
dim shared zw3 as ubyte=&ha8
dim shared zw4 as ubyte=&h54
dim shared zw5 as ubyte=&h4c
dim shared zw6 as ubyte=&h70
dim shared zw7 as ubyte=&hfc
dim shared zw8 as ubyte=&he4
dim shared zw9 as ubyte=&hb8
dim shared haa as double
dim shared hbb as double
dim shared correction1 as double 'correction de linearit des mixers
dim shared correction2 as double
dim shared vua as double 'affichage des vumetres
dim shared vub as double
dim shared usbcom as short
dim shared usbcomm as short
dim shared portcom as string
dim shared bubu as string
dim shared xist1 as string

declare sub dessin1
declare sub dessin2
declare sub verif
declare sub markers
declare sub calcul
declare sub acqui
declare sub frequence
declare sub menu
declare sub z2sub
declare sub z4sub
declare sub z14sub
declare sub z6sub
declare sub help
declare sub adjust
declare sub savefile
declare sub efasse
declare sub ecribmp
declare sub s2ps21
declare sub s2ps12
declare sub s21s12
declare sub s2112dja
declare sub wheel1
declare sub wheel2
declare sub setport

palette 0,&h00,&h00,&h00
palette 1,&h90,&h90,&h00
palette 2,&h00,&ha8,&h00
palette 3,&h00,&ha8,&ha8
palette 4,&h00,&h00,&h00
palette 5,&h00,&h00,&h00
palette 6,&ha8,&h54,&h00
palette 7,&h00,&h4c,&h4c
palette 8,&h54,&h54,&h54
palette 9,&h70,&h70,&h70
palette 10,&h54,&hfc,&h54
palette 11,&h00,&h00,&h00
palette 12,&hfc,&h54,&h54
palette 13,&hfc,&h54,&hfc
palette 14,&hfc,&hfc,&h54
palette 15,&hfc,&he4,&hb8



bobo="configu"
rep=fix((largeur+bor)/8)+1

curseur1=cursor1*(nb-1)/largeur
curseur2=cursor2*(nb-1)/largeur
miin(0)=-100 :miin(1)=0 :miin(2)=-100 
maax(0)=0    :maax(1)=1 :maax(2)=0    
maxa(0)=225  :maxa(1)=225 :maxa(2)=100 
mina(0)=-225 :mina(1)=-225 :mina(2)=0  
'shell "stty -F /dev/ttyUSB0 57600 rows 0 columns 0 min 0 -hupcl clocal -brkint inpck -icrnl -ixon -ixany -imaxbel -iutf8 -opost -onlcr -isig -icanon -iexten -echo -echoe -echok -echoctl -echoke" 


sub dessin1
    
screenset 2,0
pa=0 :if ti=2 then pa=ap '
line (bor,bor)-(bor+largeur,bor+hauteur),7,bf
couleur=8
if linlog=0 then
    for i=0 to 10  'quadrillage lineaire sur l'axe des frequences
        couleur=8 :if i=5 then couleur=9
        line (bor+largeur*i/10,bor)-(bor+largeur*i/10,bor+hauteur),couleur
    next i
else    'quadrillage logarithmique sur l'axe des frequences
    dim nbdec as integer
    dim hi as integer
    dim frec as double
    dim xxx as double
    nbdec=fix(log(fstart)/log(10))
    hi=fix(fstart/(10^nbdec))+1
    frec=hi*10^nbdec
    while (((hi)*(10^nbdec))<=fstop)
        while((hi<10) and ((hi)*(10^nbdec))<=fstop)
            frec=hi*(10^nbdec)
            xxx=log(frec/fstart)*largeur/log(fstop/fstart)
            if hi=1 then couleur=9
            line(bor+xxx,bor)-(bor+xxx,bor+hauteur),couleur
            if hi=1 then couleur=8
            hi=hi+1
        wend
        nbdec=nbdec+1
        hi=1
    wend
end if
for i=0 to 10     'quadrillage lineaire en ordonne
    couleur=8 :if i=5 then couleur=9
    line (bor,bor+hauteur*i/10)-(bor+largeur,bor+hauteur*i/10),couleur
next i



    'vumeter 
    line(bor+largeur+150,bor+hauteur-157)-(bor+largeur+200,bor+hauteur-5),9,b
    for i=0 to 11
        line(bor+largeur+163,bor+hauteur-136+10*i)-(bor+largeur+200-13,bor+hauteur-136+10*i),9
    next i
    line(bor+largeur+160,bor+hauteur-126)-(bor+largeur+200-10,bor+hauteur-126),3
    line(bor+largeur+159,bor+hauteur-76)-(bor+largeur+200-9,bor+hauteur-76),3
    line(bor+largeur+160,bor+hauteur-26)-(bor+largeur+200-10,bor+hauteur-26),3
    line(bor+largeur+156,bor+hauteur-136)-(bor+largeur+158,bor+hauteur-16),0,bf
    line(bor+largeur+192,bor+hauteur-136)-(bor+largeur+194,bor+hauteur-16),0,bf
    locate 36,123 :print "0"  :locate 35,121 :print "A" :locate 35,125 :print "R"
    locate 39,122 :print "-50"
    locate 43,122 :print "dBm"
    screenset 1,0
    screencopy 2,1
'screenset 0,0
'screencopy 1,0
end sub    

sub dessin2
    'screenset 1,0
    'screencopy 2,1
    if va=1 then  'trait vertical pour montrer que ca mesure
        line (bor+largeur*p/(nb-1),bor)-(bor+largeur*p/(nb-1),bor+hauteur),8
    end if
    line (bor+cursor1,bor)-(bor+cursor1,hauteur+bor),12 'dessin des curseurs
    line (bor+cursor2,bor)-(bor+cursor2,hauteur+bor),13
    ga=hauteur/(maax(ti)-miin(ti))
    ma=hauteur*maax(ti)/(maax(ti)-miin(ti))
    limite=pmax
    if complet=1 then limite=nb-1
    if ef=1 then limite=0
    for i=1 to limite  'dessin de la courbe jusqu'a pmax ou nb-1
        oaf=bor+ma-ga*a1(i-1)
        oaf2=bor+ma-ga*a1(i)
        if oaf2>hauteur+bor then oaf2=hauteur+bor
        if oaf>hauteur+bor then oaf=hauteur+bor
        if oaf2<bor then oaf2=bor
        if oaf<bor then oaf=bor
        line(bor+largeur*(i-1)/(nb-1),oaf)-(bor+largeur*(i)/(nb-1),oaf2),14
        if (dis=2 or dis=3) and m1m2=1 and complet=1 then
            ouf=bor+ma-ga*aa(i-1)
            ouf2=bor+ma-ga*aa(i)
            if ouf2>hauteur+bor then ouf2=hauteur+bor
            if ouf>hauteur+bor then ouf=hauteur+bor
            if ouf2<bor then ouf2=bor
            if ouf<bor then ouf=bor
            line(bor+largeur*(i-1)/(nb-1),ouf)-(bor+largeur*i/(nb-1),ouf2),1
        end if
    next i
    if dis=4 and ti=0 then
        for i=1 to limite 'dessin du niveau du signal sur l'entree A
            oaa=bor+ma-ga*ha(i-1)*20
            oaa2=bor+ma-ga*ha(i)*20
            if oaa2>hauteur+bor then oaa2=hauteur+bor
            if oaa>hauteur+bor then oaa=hauteur+bor
            if oaa2<bor then oaa2=bor
            if oaa<bor then oaa=bor
            line(bor+largeur*(i-1)/(nb-1),oaa)-(bor+largeur*(i)/(nb-1),oaa2),3
        next i
        for i=1 to limite 'dessin du niveau du signal sur l'entree A
            oaa=bor+ma-ga*hb(i-1)*20
            oaa2=bor+ma-ga*hb(i)*20
            if oaa2>hauteur+bor then oaa2=hauteur+bor
            if oaa>hauteur+bor then oaa=hauteur+bor
            if oaa2<bor then oaa2=bor
            if oaa<bor then oaa=bor
            line(bor+largeur*(i-1)/(nb-1),oaa)-(bor+largeur*(i)/(nb-1),oaa2),13
        next i    
    end if
if va=1 then 'vumeter 
    vua=ha(p)
    vub=hb(p)
    'if ha(p)<-5 then ha(p)=-5
    'if hb(p)<-5 then hb(p)=-5
    if vua<-5 then vua=-5
    if vub<-5 then vub=-5
    'line(bor+largeur+192,bor+hauteur-126-20*hb(p))-(bor+largeur+194,bor+hauteur-26),2,bf  'vumetre
    'line(bor+largeur+156,bor+hauteur-126-20*ha(p))-(bor+largeur+158,bor+hauteur-26),2,bf
    line(bor+largeur+192,bor+hauteur-126-20*vub)-(bor+largeur+194,bor+hauteur-26),2,bf  'vumetre
    line(bor+largeur+156,bor+hauteur-126-20*vua)-(bor+largeur+158,bor+hauteur-26),2,bf
    if 20*vub>7 then
        line (bor+largeur+192,bor+hauteur-126-20*vub)-(bor+largeur+194,bor+hauteur-133),12,bf
    end if
    if 20*vua>7 then
        line (bor+largeur+156,bor+hauteur-126-20*vua)-(bor+largeur+158,bor+hauteur-133),12,bf
    end if
end if

  
maa=bor+hauteur*maxa(ti)/(maxa(ti)-mina(ti))
gaa=hauteur/(maxa(ti)-mina(ti))
for i=1+pa/2 to limite-pa/2  'dessin de la courbe jusqu'a pmax ou nb-1
    oap=maa-gaa*t1(i-1)
    oap2=maa-gaa*t1(i)    
    if oap2>hauteur+bor then oap2=hauteur+bor
    if oap>hauteur+bor then oap=hauteur+bor
    if oap2<bor then oap2=bor
    if oap<bor then oap=bor 
    if (dis=0 or dis=2)  then    
        line(bor+largeur*(i-1)/(nb-1),oap)-(bor+largeur*(i)/(nb-1),oap2),10
    end if
    if dis=2 and m1m2=1 and complet=1 then
        oup=maa-gaa*tt(i-1)
        oup2=maa-gaa*tt(i)
        if oup2>hauteur+bor then oup2=hauteur+bor
        if oup>hauteur+bor then oup=hauteur+bor
        if oup2<bor then oup2=bor
        if oup<bor then oup=bor
        line(bor+largeur*(i-1)/(nb-1),oup)-(bor+largeur*(i)/(nb-1),oup2),2
    end if
next i
if cal=1 then
    locate 20,20 :color 0,15
    print " Replace the device under test with a     "
    locate 21,20
    print " through connection, then start normalize "
    color 15,0
end if
if va=1 then  'pour pouvoir afficher stop en inverse video pendant la mesure
    if x>(rep+1)*8 and x<(rep+17)*8 and y>431+16*8 and y<448+16*8 then
        locate 36,rep+2 :color 0,15
        if va=1 and (cal<1 or cal>2) then print " Stop           "
        if va=1 and cal=2 then print " Abort normalize"
        color 15,0
    else
        locate 36,rep+2 :color 15,0
        if va=1 and (cal<1 or cal>2) then print " Stop           "
        if va=1 and cal=2 then print " Abort normalize"
    end if
    line ((rep+1)*8,431+16*8)-((rep+17)*8,448+16*8),14,b
end if
'locate 46,70 :print "haa";haa;"     "
'locate 47,70 :print "hbb";hbb;"     " ':sleep 3000
'locate 46,70 :print "1 ";correction1;"   "
'locate 47,70 :print "2 ";correction2;"   "
screenset 0,0
screencopy 1,0
end sub


sub verif
    if miin(ti)>maax(ti) then
        erreur1=1
        locate 31,rep+2 :color 0,6
        print "        Error          "
        locate 32,rep+2 
        print "  Gain Max < Gain Min  "
        color 15,0
    else
        erreur1=0
    end if
    if mina(ti)>maxa(ti) then
        erreur2=1
        locate 31,rep+2 :color 0,6
        print "        Error          "
        locate 32,rep+2
        if ti=2 then print " Delay Max < Delay Min "
        if ti=0 or ti=1 then print " Phase Max < Phase Min "
        color 15,0
    else
        erreur2=0
    end if
    if fstart>fstop then
        erreur3=1
        locate 31,rep+2 :color 0,6
        print "        Error          "
        locate 32,rep+2
        print "  Freq Max < Freq Min  "
        color 15,0
    else
        erreur3=0
    end if
    if cente=1 then
        if center+span/2>99999999.98 then
            erreur4=1
            locate 31,rep+2 :color 0,6
            print "        Error          "
            locate 32,rep+2
            print "Center + Span/2 > 99MHz"
            color 15,0
        else
            erreur4=0
        end if
        if (center-span/2)<10 then
            erreur5=1
            locate 31,rep+2 :color 0,6
            print "        Error          "
            locate 32,rep+2
            print "Center - Span/2 < 20Hz "
            color 15,0
        else
            erreur5=0
        end if
    end if
    
    if cente=1 then
        fstart=center-span/2
        fstop=center+span/2
    end if
    if cente=0 then
        center=(fstart+fstop)/2
        span=fstop-fstart
    end if
    if ap>8*(nb-1)/50 then ap=8*(nb-1)/50
end sub



sub markers
    screenset 1,0
    tupeu=1
    if (complet=1) or (pmax>=curseur1) then
        locate 45,13 :print using "#########.##";freq(curseur1)
        if (ti=0 or ti=2) then
            locate 45,31 :print using "#####.#####";a1(curseur1)
        else
            locate 45,28 :print using "########.######";a1(curseur1)
        end if
        
        'locate 45,44 :print using "######.#####";t1(curseur1)
        if (ti=0 or ti=1) then
            locate 45,46 :print using "######.#####";t1(curseur1)
        else
            if ti=2 and curseur1>=ap/2 and (curseur1<=pmax-ap/2 or (complet=1 and curseur1<=(nb-1-ap/2))) then
                locate 45,46 :print using "######.######";t1(curseur1)
            else
                locate 45,46 :print "             " :tupeu=0
            end if
        end if        
    else
        locate 45,13 :print "            "
        locate 45,28 :print "               "
        locate 45,46 :print "            "
        if ti=2 then locate 45,46 :print "             "
    end if
    if (complet=1) or (pmax>=curseur2) then
        locate 46,13 :print using "#########.##";freq(curseur2)
        if (ti=0 or ti=2) then
            locate 46,31 :print using "#####.#####";a1(curseur2)
        else
            locate 46,28 :print using "########.######";a1(curseur2)
        end if
        if (ti=0 or ti=1) then
            locate 46,46 :print using "######.#####";t1(curseur2)
        else
            if ti=2 and curseur2>=ap/2 and (curseur2<=pmax-ap/2 or (complet=1 and curseur2<=(nb-1-ap/2))) then
                locate 46,46 :print using "######.######";t1(curseur2)
            else
                locate 46,46 :print "             " :tupeu=0
            end if
        end if
    else
        locate 46,13 :print "            "
        locate 46,28 :print "               "
        locate 46,46 :print "            "
        if ti=2 then locate 45,46 :print "             "
    end if
    if (complet=1) or ((pmax>=curseur1) and (pmax>=curseur2)) then
        locate 47,13 :print using "#########.##";freq(curseur2)-freq(curseur1)
        if (ti=0 or ti=2) then
            locate 47,31 :print using "#####.#####";a1(curseur2)-a1(curseur1)
        else
            locate 47,28 :print using "########.######";a1(curseur2)-a1(curseur1)
        end if
        if tupeu=1 and (ti=0 or ti=1) then
            locate 47,46 :print using "######.#####";t1(curseur2)-t1(curseur1)
        else
            locate 47,46 :print "            "
        end if
        if tupeu=1 and ti=2 then
            locate 47,46 :print using "######.######";t1(curseur2)-t1(curseur1)
        end if
        if ti=2 and tupeu=0 then
            locate 47,46 :print "             "
        end if        
    else
        locate 47,13 :print "            "
        locate 47,28 :print "               "
        locate 47,46 :print "            "
        if ti=2 then locate 47,46 :print "             " 
    end if
end sub


sub calcul
    if va=1 then
        'calcul sur les mesures
        t=0
        za1=0 :za2=0 :wa1=0 :wa2=0
        for i=0 to nbsamp
            za1=za1+sin(2*pi*i/7)*Q(i)
            wa1=wa1+cos(2*pi*i/7)*Q(i)
            za2=za2+sin(2*pi*i/7)*M(i)
            wa2=wa2+cos(2*pi*i/7)*M(i)
        next i
        haa=(1.613*(sqr(za1^2+wa1^2))/(2^32)*7/(nbsamp+1)) 'correction de linarite des mixers
        hbb=(1.613*(sqr(za2^2+wa2^2))/(2^32)*7/(nbsamp+1))
        correction1=34.0333/(34.0333-0.0216*haa^2) 
        correction2=34.0333/(34.0333-0.0216*hbb^2) 
        za1=za1*correction1 :wa1=wa1*correction1
        za2=za2*correction2 :wa2=wa2*correction2
        wa1=wa1/ggain 'correction en amplitude entre la voie 1 et la voie 2
        za1=za1/ggain
        angle=-(pphas/360)*2*pi 'correction angulaire de la dissymetrie des filtres passe-bas
        wc1=wa1*cos(angle)-za1*sin(angle)
        zc1=wa1*sin(angle)+za1*cos(angle)
        wa1=wc1 :za1=zc1
    
        'calcul de v2/v1 fonction de transfert
        w33(p)=(wa1*wa2+za1*za2)/(wa2^2+za2^2)
        z33(p)=(za1*wa2-wa1*za2)/(wa2^2+za2^2)
        'w33(p)=wa3 :z33(p)=za3
        wa3=w33(p) :za3=z33(p)
        w3L(p)=w33(p) :z3L(p)=z33(p)
    else
        wa3=w33(p) :za3=z33(p)
    end if
    Ma1=M1(p) :Ma2=M2(p)
    
    if cal=0 then
        if lon<>0 then 'correction de longueur entre voie1 et voie2
            angle=lon*2*pi*freq(p)/299792458
            wc1=wa3*cos(angle)-za3*sin(angle)
            zc1=wa3*sin(angle)+za3*cos(angle)
            wa3=wc1 :za3=zc1
            wc1=Ma1*cos(angle)-Ma2*sin(angle)
            zc1=Ma1*sin(angle)+Ma2*cos(angle)
            Ma1=wc1 :Ma2=zc1
        end if
        w3L(p)=wa3 :z3L(p)=za3  'pour group delay
        M1L(p)=Ma1 :M2L(p)=Ma2
    end if
    if cal=2 then 'mise en memoire des tableaux de calibration
        wt(p)=w3L(p) :zt(p)=z3L(p)
    end if
    
    if cal<3 then
        if ti=0 or ti=2 then
            'a1(p)=-20*(log(sqr(w33(p)^2+z33(p)^2))/log(10))
            a1(p)=20*(log(sqr(w3L(p)^2+z3L(p)^2))/log(10))
            if (dis=2 or dis=3) and m1m2=1 and complet=1 then ' and modif=1 then
                aa(p)=20*(log(sqr(M1L(p)^2+M2L(p)^2))/log(10))
            end if
        end if
        if ti=1 then
            'a1(p)=sqr(wa3^2+za3^2)
            a1(p)=sqr(w3L(p)^2+z3L(p)^2)
            if (dis=2 or dis=3) and m1m2=1 and complet=1 then 'and modif=1 then
                aa(p)=sqr(M1L(p)^2+M2L(p)^2)
            end if
        end if
    else
        wnd(p)=(w3L(p)*wt(p)+z3L(p)*zt(p))/(wt(p)^2+zt(p)^2)
        znd(p)=(z3L(p)*wt(p)-w3L(p)*zt(p))/(wt(p)^2+zt(p)^2)
        if (dis=2 or dis=3) and m1m2=1 and complet=1 then 'and modif=1 then
            wndd(p)=(Ma1*wt(p)+Ma2*zt(p))/(wt(p)^2+zt(p)^2)
            zndd(p)=(Ma2*wt(p)-Ma1*zt(p))/(wt(p)^2+zt(p)^2)
            'wndd(p)=wndd :zndd(p)=zndd
        end if
        if ti=0 or ti=2 then
            a1(p)=20*log(sqr(wnd(p)^2+znd(p)^2))/log(10)
            if (dis=2 or dis=3) and m1m2=1 and complet=1 then 'eff=0 and modif=1 then
                aa(p)=20*log(sqr(wndd(p)^2+zndd(p)^2))/log(10)
            end if
        end if
        if ti=1 then
            a1(p)=sqr(wnd(p)^2+znd(p)^2)
            if (dis=2 or dis=3) and m1m2=1 and complet=1 then 'eff=0 and modif=1 then
                aa(p)=sqr(wndd(p)^2+zndd(p)^2)
            end if
        end if
    end if
    if cal=2 then 'mise en memoire des tables de calibration
        wt(p)=wa3 :zt(p)=za3
    end if
    if va=1 then
        ha(p)=log(1.613*(sqr(za1^2+wa1^2))/(2^32)*7/(nbsamp+1))/log(10) 'calcul du niveau sur les voies
        hb(p)=log(1.613*(sqr(za2^2+wa2^2))/(2^32)*7/(nbsamp+1))/log(10) ' 1 et 2
        haa=(1.613*(sqr(za1^2+wa1^2))/(2^32)*7/(nbsamp+1))
        hbb=(1.613*(sqr(za2^2+wa2^2))/(2^32)*7/(nbsamp+1))
    end if
    if ti=0 or ti=1 then
        if cal<3 then
            t1(p)=atan2(z3L(p),w3L(p))
            if dis=2 and m1m2=1 and complet=1 then
                tt(p)=atan2(M2L(p),M1L(p))
             end if
        else
            t1(p)=atan2(znd(p),wnd(p))
            tt(p)=atan2(zndd(p),wndd(p))
        end if
        t1(p)=t1(p)*(180/pi)
        tt(p)=tt(p)*(180/pi)
    end if
    if ti=2 and cal<3 then
        if p>ap-1 then
            wa6=w3L(p)*w3L(p-ap)+z3L(p)*z3L(p-ap)
            za6=w3L(p-ap)*z3L(p)-w3L(p)*z3L(p-ap)
            dfi=atan2(za6,wa6)
            t1(p-ap/2)=-dfi/((freq(p)-freq(p-ap))*2*pi)*1000000
            if dis=2 and m1m2=1 and complet=1 then
                wa6=M1L(p)*M1L(p-ap)+M2L(p)*M2L(p-ap)
                za6=M1L(p-ap)*M2L(p)-M1L(p)*M2L(p-ap)
                dfi=atan2(za6,wa6)
                tt(p-ap/2)=-dfi/((freq(p)-freq(p-ap))*2*pi)*1000000
            end if
        end if
    end if
    if ti=2 and cal>2 then
        if p>ap-1 then
            wa6=wnd(p)*wnd(p-ap)+znd(p)*znd(p-ap)
            za6=wnd(p-ap)*znd(p)-wnd(p)*znd(p-ap)
            dfi=atan2(za6,wa6)
            t1(p-ap/2)=-dfi/((freq(p)-freq(p-ap))*2*pi)*1000000
            if dis=2 and m1m2=1 and complet=1 then
                wa6=wndd(p)*wndd(p-ap)+zndd(p)*zndd(p-ap)
                za6=wndd(p-ap)*zndd(p)-wndd(p)*zndd(p-ap)
                dfi=atan2(za6,wa6)
                tt(p-ap/2)=-dfi/((freq(p)-freq(p-ap))*2*pi)*1000000
            end if
        end if
    end if
end sub

sub acqui
    'startorder
    usberror=0
    time5=timer    
    if nbsamp=6 then plouf=64
    if nbsamp=13 then plouf=65
    if nbsamp=27 then plouf=66
    if nbsamp=55 then plouf=67
    if nbsamp=111 then plouf=68
    if nbsamp=223 then plouf=69
    if nbsamp=447 then plouf=70
    if nbsamp=895 then plouf=71
    startorder=chr(plouf)
    print #f,startorder;
    received=""
    sleep 30 :relax=1
    while len(received) <(7*(nbsamp+1)+1)

        t=len(received)
        if t>50*relax then
            getmouse x,y,wheel,bouton
            if x>(rep+1)*8 and x<(rep+17)*8 and y>431+16*8 and y<448+16*8 then
                if zq22=0 then
                    locate 36,rep+2 :color 0,15
                    if  (cal<1 or cal>2) then print " Stop           "
                    if  cal=2 then print " Abort normalize"
                    zq22=1 :color 15,0
                end if
            else
                if zq22=1 then
                    locate 36,rep+2 :color 15,0
                    if va=1 and (cal<1 or cal>2) then print " Stop           "
                    if va=1 and cal=2 then print " Abort normalize"
                    zq22=0 :line ((rep+1)*8,431+16*8)-((rep+17)*8,448+16*8),14,b
                end if
            end if
            if zq22=1 then 'bouton start 
            if bouton=0 then cleft=0                
                if bouton=1 and cleft=0 then
                    stoprequest=1 
                    cleft=1 :zq22=0
                    if (nbsamp-t/7)>50 then
                        locate 31,rep+2 :color 0,14 
                        print "      Wait      " :color 15,0
                    end if                    
                end if
            end if            
            sleep 14 :relax=relax+1
            getmouse x,y,wheel,bouton
            if x>(rep+1)*8 and x<(rep+17)*8 and y>431+16*8 and y<448+16*8 then
                if zq22=0 then
                    locate 36,rep+2 :color 0,15
                    if  (cal<1 or cal>2) then print " Stop           "
                    if  cal=2 then print " Abort normalize"
                    zq22=1 :color 15,0
                end if
            else
                if zq22=1 then
                    locate 36,rep+2 :color 15,0
                    if va=1 and (cal<1 or cal>2) then print " Stop           "
                    if va=1 and cal=2 then print " Abort normalize"
                    zq22=0 :line ((rep+1)*8,431+16*8)-((rep+17)*8,448+16*8),14,b
                end if
            end if
            if zq22=1 then 'bouton start 
            if bouton=0 then cleft=0                
                if bouton=1 and cleft=0 then
                    stoprequest=1 
                    cleft=1 :zq22=0
                    if (nbsamp-t/7)>50 then
                        locate 31,rep+2 :color 0,14 
                        print "      Wait      " :color 15,0
                    end if                    
                end if
            end if
            sleep 14
        end if
        
        l=inkey$
        if  l=" " and (cal<1 or cal>6) then
            stoprequest=1 :zq22=0
            if (nbsamp-t/7)>50 then
                locate 31,rep+2 :color 0,14 
                print "      Wait      " :color 15,0
            end if
        end if
        getmouse x,y,wheel,bouton
        if x>(rep+1)*8 and x<(rep+17)*8 and y>431+16*8 and y<448+16*8 then
            if zq22=0 then
                locate 36,rep+2 :color 0,15
                if  (cal<1 or cal>2) then print " Stop           "
                if  cal=2 then print " Abort normalize"
                zq22=1 :color 15,0
            end if
        else
            if zq22=1 then
                locate 36,rep+2 :color 15,0
                if va=1 and (cal<1 or cal>2) then print " Stop           "
                if va=1 and cal=2 then print " Abort normalize"
                zq22=0 :line ((rep+1)*8,431+16*8)-((rep+17)*8,448+16*8),14,b
            end if
        end if
        if zq22=1 then 'bouton start 
            if bouton=0 then cleft=0                
            if bouton=1 and cleft=0 then
                stoprequest=1 
                cleft=1 :zq22=0
                if (nbsamp-t/7)>50 then
                    locate 31,rep+2 :color 0,14 
                    print "      Wait      " :color 15,0
                end if                    
            end if
        end if
        sleep 0.1
        if loc(f)>0 then
            ressu=input(loc(f),f)
            received=received+ressu
        end if
        time6=timer
        if time6-time5>7 then usberror=1 :goto timeout
    wend
    for t=0 to nbsamp
        M(t)=0 :Q(t)=0
        for k=0 to 6
            'get #f, ,fx
            fx=asc(left(received,1))
            'locate k+1,t*4+1 :print fx 
            if k=0 then goto sotte
            if bit(fx,7)=-1 then M(t)=bitset(M(t),31-(k-1)*4)
            if bit(fx,6)=-1 then Q(t)=bitset(Q(t),31-(k-1)*4)
            if bit(fx,5)=-1 then M(t)=bitset(M(t),30-(k-1)*4)
            if bit(fx,4)=-1 then Q(t)=bitset(Q(t),30-(k-1)*4)
            if bit(fx,3)=-1 then M(t)=bitset(M(t),29-(k-1)*4)
            if bit(fx,2)=-1 then Q(t)=bitset(Q(t),29-(k-1)*4)
            if bit(fx,1)=-1 then M(t)=bitset(M(t),28-(k-1)*4)
            if bit(fx,0)=-1 then Q(t)=bitset(Q(t),28-(k-1)*4)
            sotte:
            received=right(received,(len(received)-1))
        next k
        continu:
    next t
    timeout:    
end sub

sub frequence
    'zute1=timer
    N1=Cuint((freq(p)* &h100000000)/cclock)  'N1=entier a mettre dans DDS1
    N2=N1+716 'calcul de l'entier a renter dans DDS2 pour avoir 25.006011Hz
    'de plus que dans DDS1, si la frequence de l'horloge est 150MHz
    'ecriture des 40 bits  dans les 2 genes DDS
    'ecriture de la frequence  LSB en premier

    bid =&hc0
    'put #f, ,bid 'commande pour dire a arduino que l'on va envoyer la frequence
    freqecri=chr(bid)
    print #f,freqecri;
    sleep 1
    freqstring=""
    for i = 0 to 7
        bid = 0
        if bit(N1, 4*i)=-1 then bid = bitset (bid,0)
        if bit(N2, 4*i)=-1 then bid = bitset (bid,1)
        if bit(N1, 4*i+1)=-1 then bid = bitset (bid,2)
        if bit(N2, 4*i+1)=-1 then bid = bitset (bid,3)
        if bit(N1, 4*i+2)=-1 then bid = bitset (bid,4)
        if bit(N2, 4*i+2)=-1 then bid = bitset (bid,5)
        if bit(N1, 4*i+3)=-1 then bid = bitset (bid,6)
        if bit(N2, 4*i+3)=-1 then bid = bitset (bid,7)

        'put #f, , bid   'envoie de 8 bytes a arduino pour la frequence de dds1 & dds2
        freqstring=freqstring+chr(bid)
    next i
    print #f,freqstring;
end sub

sub resetz
   z1=0 :z2=0 :z3=0 :z4=0 :z5=0 :z6=0 :z7=0 :z8=0 :z9=0 :z10=0 :z11=0
    z12=0 :z13=0 :z14=0 :z15=0 :z16=0 :z17=0 :z18=0
    z22=0 :z23=0 :z24=0 :z25=0
end sub


sub menu
screenset 2,0
cls
color 14
if ti=0 then
    locate 1,rep+2
    print "gain & phase vs frequency"
    locate 2,rep+2
    print "    gain: dB scale "
    locate 3,rep+2
    print "      dB & degres "
end if
if ti=1 then
    locate 1,rep+2
    print "gain & phase vs frequency"
    locate 2,rep+2
    print "gain: linear scale (Unit)"
    locate 3,rep+2
    print "      U & degres "
end if
if ti=2 then
    locate 1,rep+2
    print "gain & delay vs frequency"
    locate 2,rep+2
    print "    gain: dB scale "
    locate 3,rep+2
    print "      dB & us "
end if

locate 6,rep+2 :color 14
print "gain"
locate 7,rep+2
if ti=0 or ti=2 then print "(dB)"
if ti=1 then print "(U)"
locate 6,rep+8 :color 15
print "Max:"
locate 6,rep+12
print using "#######.#####";maax(ti)
locate 7,rep+8 :color 15
print "MIN:"
locate 7,rep+12 
print using "#######.#####";miin(ti)
locate 8,rep+7 :color 15
print "/div:"
locate 8,rep+12
print using "#######.#####";(maax(ti)-miin(ti))/10
locate 10,rep+2 :color 10
if ti=0 or ti=1 then print "phase"
if ti=2 then print "delay"
locate 11,rep+2
if ti=0 or ti=1 then print "(deg)"
if ti=2 then print "(us)"
locate 10,rep+8 :color 15
print "Max:"
locate 10,rep+12
print using "#######.#####";maxa(ti)
locate 11,rep+8 
print "MIN:"
locate 11,rep+12
print using "#######.#####";mina(ti)
locate 12,rep+7
print "/div:"
locate 12,rep+12
print using "#######.#####";(maxa(ti)-mina(ti))/10

locate 14,rep+2 :color 15
print "freq  Max:"
locate 14,rep+13
print using "#########.##";fstop
locate 15,rep+2 
print "(Hz)  Min:"
locate 15,rep+13
print using "#########.##";fstart
if linlog=0 then
    locate 16,rep+7
    print "/div:"
    locate 16,rep+13
    print using "#########.##";(fstop-fstart)/10
    locate 17,rep+5
    print "center:"
    locate 17,rep+13
    print using "#########.##";center
    locate 18,rep+7
    print "span:"
    locate 18,rep+13
    print using "#########.##";span
end if
locate 20,rep+6
if linlog=0 then print "sweep: linear"
if linlog=1 then print "sweep: log   "
locate 21,rep+2
print "meas/scan:";nb
locate 22,rep+4
print "ms/meas:";40*(nbsamp+1)/7
if ti=2 then
    locate 23,rep+1
'    print "delay aper:";ap/4;"%"
    print "delay aper:";(ap/4)*400/(nb-1);"%"
end if
if cal=0 then
    locate 24,rep+2
    print "length(m):"
    locate 24,rep+13
    print using "####.####";lon
end if
locate 25,rep+2
if cal=0 then print "normalize: off    "
if cal=1 then print "normalize: asked  "
if cal=2 then print "normalize: running"
if cal=3 then print "normalize: on     "
if cal=4 then print "normalize: warning"
locate 26,rep+4
print "display:"
locate 26,rep+13
if ti=1 then
 if dis=4 then dis=0
 if dis=2 and M1M2=0 then dis=0
 if dis=3 and M1M2=0 then dis=1
 if dis=0 then print "U,deg       "
 if dis=1 then print "U           "
 if dis=2 then print "U,deg, + Mem"
 if dis=3 then print "U + Mem     "
end if
if ti=2 then
 if dis=4 then dis=0
 if dis=2 and M1M2=0 then dis=0
 if dis=3 and M1M2=0 then dis=1
 if dis=0 then print "dB,us       "
 if dis=1 then print "dB          "
 if dis=2 then print "dB,us, + Mem"
 if dis=3 then print "dB + Mem    "
end if
if ti=0 then
 if dis=2 and M1M2=0 then dis=0
 if dis=3 and M1M2=0 then dis=1
 if dis=0 then print "dB,deg      "
 if dis=1 then print "dB          "
 if dis=2 then print "dB,deg,+ Mem"
 if dis=3 then print "dB + Mem    "
 if dis=4 then print "dB,A,R      "
 if dis=4 then 
     locate 26,rep+16 :color 3 :print "A"
     locate 26,rep+18 :color 13 :print "R" : color 15
 end if
 
end if

locate 28,rep+3
print "Copy measure to Memory"
locate 29,rep+3
print "Save measure to File" 

locate 36,rep+2
if va=1 and (cal<1 or cal>2) then print " Stop    "
if va=0 and cal=1 then print " Start normalize"
if va=1 and cal=2 then print " Abort normalize"
if va=0 and (cal<1 or cal>2) then print " Start  "
locate 38,rep+2
print " Help "
locate 40,rep+2
print " Adjustment "
locate 42,rep+2
print " Exit "

    
locate 45,2
print "marker   1:             Hz               dB              deg "
color 14 :locate 45,43 :print "dB" :color 10 :locate  45,59 :print "deg" :color 15
locate 46,2
print "marker   2:             Hz               dB              deg "
color 14 :locate 46,43 :print "dB" :color 10 :locate  46,59 :print "deg" :color 15
locate 47,2
print "marker 2-1:             Hz               dB              deg "
color 14 :locate 47,43 :print "dB" :color 10 :locate  47,59 :print "deg" :color 15
if ti=1 then
 color 14
 locate 45,43 :print " U" :locate 46,43 :print " U" :locate 47,43 :print " U"
end if
if ti=2 then
 color 10
 locate 45,59 :print "  us" :locate 46,59 :print "  us" :locate 47,59 :print "  us"
end if
locate 45,11 :color 12 :print "1"  :locate 47,11 :print "1"
locate 46,11 :color 13 :print "2"  :locate 47,9 :print "2" :color 15 

end sub

sub z2sub 'pour editer gain max et gain min
    if num=1 then num=0 :goto numeric
    atenchar:
    l=inkey$
    sleep 2
    if l="" then goto atenchar
    if asc(l,1)=27 then
        sort=1 :goto finz2sub
    end if
    l=left$(l,1)
    if asc(l)>44 and asc(l)<58 and not(asc(l)=47) then
        numeric:
        if len(aw)<13 then
            aw=aw+l
            if z2=1 then 
                locate 6,rep+12 :color 0,14
                print "             "
                locate 6,rep+12 :print aw
            end if
            if z3=1 then 
                locate 7,rep+12 :color 0,14
                print "             "
                locate 7,rep+12 :print aw
            end if            
            'cente=0
        end if
    end if
    if asc(l)=8 then
        lu=len(aw)
        if lu>0 then lu=lu-1
        aw=left$(aw,lu)
        if z2=1 then 
            locate 6,rep+12 :color 0,14
            print "             "
            locate 6,rep+12 :print aw
        end if
        if z3=1 then 
            locate 7,rep+12 :color 0,14
            print "             "
            locate 7,rep+12 :print aw
        end if        
    end if
    if asc(l)=13 then
        fdd=val(aw)
        if fdd>-500 and fdd<9999999.9998 then
            if z2=1 then maax(ti)=fdd
            if z3=1 then miin(ti)=fdd
            aw="" 'on vide le buffer de caracteres
            goto finz2sub
        end if
        if z2=1 then locate 6,rep+12
        if z3=1 then locate 7,rep+12
        print "             "
        aw=""
        goto atenchar
    end if
    goto atenchar
    finz2sub:
    color 15,0
end sub

sub z4sub  'pour editer phase (delay) max et min
    if num=1 then num=0 :goto numeric
    atenchar:
    l=inkey$
    sleep 2
    if l="" then goto atenchar
    if asc(l,1)=27 then
        sort=1 :goto finz4sub
    end if
    l=left$(l,1)
    if asc(l)>44 and asc(l)<58 and not(asc(l)=47) then
        numeric:
        if len(aw)<11 then
            aw=aw+l
            if z4=1 then 
                locate 10,rep+12 :color 0,14
                print "             "
                locate 10,rep+12 :print aw
            end if
            if z5=1 then 
                locate 11,rep+12 :color 0,14
                print "             "
                locate 11,rep+12 :print aw
            end if            
            'cente=0
        end if
    end if
    if asc(l)=8 then
        lu=len(aw)
        if lu>0 then lu=lu-1
        aw=left$(aw,lu)
        if z4=1 then 
            locate 10,rep+12 :color 0,14
            print "             "
            locate 10,rep+12 :print aw
        end if
        if z5=1 then 
            locate 11,rep+12 :color 0,14
            print "             "
            locate 11,rep+12 :print aw
        end if        
    end if
    if asc(l)=13 then
        fdd=val(aw)
        if fdd>-999999 and fdd<9999999 then
            if z4=1 then maxa(ti)=fdd
            if z5=1 then mina(ti)=fdd
            aw="" 'on vide le buffer de caracteres
            goto finz4sub
        end if
        if z4=1 then locate 10,rep+12
        if z5=1 then locate 11,rep+12
        print "             "
        aw=""
        goto atenchar
    end if
    goto atenchar
    finz4sub:
    color 15,0
end sub
sub z14sub  'pour editer length
    if num=1 then num=0 :goto numeric
    atenchar:
    l=inkey$
    sleep 2
    if l="" then goto atenchar
    if asc(l,1)=27 then
        sort=1 :goto finz14sub
    end if
    l=left$(l,1)
    if asc(l)>44 and asc(l)<58 and not(asc(l)=47) then
        numeric:
        if len(aw)<11 then
            aw=aw+l
            if z14=1 then 
                locate 24,rep+12 :color 0,14
                print "             "
                locate 24,rep+12 :print aw
            end if
        end if
    end if
    if asc(l)=8 then
        lu=len(aw)
        if lu>0 then lu=lu-1
        aw=left$(aw,lu)
        if z14=1 then 
            locate 24,rep+12 :color 0,14
            print "             "
            locate 24,rep+12 :print aw
        end if
    end if
    if asc(l)=13 then
        fdd=val(aw)
        if fdd>-999.99991 and fdd<9999.99991 then
            lon=fdd
            aw="" 'on vide le buffer de caracteres
            goto finz14sub
        end if
        if z14=1 then locate 24,rep+12
        print "             "
        aw=""
        goto atenchar
    end if
    goto atenchar
    finz14sub:
    color 15,0
end sub

sub z6sub  'pour editer fmax , fmin, fcenter ,span
    if num=1 then num=0 :goto numeric
    atenchar:
    l=inkey$
    sleep 2
    if l="" then goto atenchar
    if asc(l,1)=27 then
        sort=1 :goto finz6sub
    end if
    l=left$(l,1)
    if asc(l)>45 and asc(l)<58 and not(asc(l)=47) then
        numeric:
        if len(aw)<11 then
            complet=0 :m1m2=0 :p=0 :newcal=1 :ef=1
            if (cal=3 or cal=4) then newcal=1
            aw=aw+l
            if z6=1 then 
                locate 14,rep+12 :color 0,14
                print "             "
                locate 14,rep+12 :print aw
            end if
            if z7=1 then 
                locate 15,rep+12 :color 0,14
                print "             "
                locate 15,rep+12 :print aw
            end if            
            'cente=0
            if z8=1 then
                locate 17,rep+12 :color 0,14
                print "             "
                locate 17,rep+12 :print aw
            end if
            if z9=1 then
                locate 18,rep+12 :color 0,14
                print "             "
                locate 18,rep+12 :print aw
            end if            
        end if
    end if
    if asc(l)=8 then
        lu=len(aw)
        if lu>0 then lu=lu-1
        aw=left$(aw,lu)
        if z6=1 then 
            locate 14,rep+12 :color 0,14
            print "             "
            locate 14,rep+12 :print aw
        end if
        if z7=1 then 
            locate 15,rep+12 :color 0,14
            print "             "
            locate 15,rep+12 :print aw
        end if
        if z8=1 then 
            locate 17,rep+12 :color 0,14
            print "             "
            locate 17,rep+12 :print aw
        end if
        if z9=1 then 
            locate 18,rep+12 :color 0,14
            print "             "
            locate 18,rep+12 :print aw
        end if        
    end if
    if asc(l)=13 then
        fdd=val(aw)
        if fdd>15 and fdd<99999999.98 then
            if z6=1 then fstop=fdd :cente=0
            if z7=1 then fstart=fdd :cente=0
            if z8=1 then center=fdd :cente=1
            if z9=1 then span=fdd :cente=1
            aw="" 'on vide le buffer de caracteres
            pmax=0 :if cal>2 then newcal=1 :cal=4
            goto finz6sub
        end if
        if z6=1 then locate 14,rep+12
        if z7=1 then locate 15,rep+12
        if z8=1 then locate 17,rep+12
        if z9=1 then locate 18,rep+12        
        print "             "
        aw=""
        goto atenchar
    end if
    if (l="M" or l="m") and val(aw)>0 then
        fdd=val(aw)*1000000
        if fdd>15 and fdd<99999999.98 then
            if z6=1 then fstop=fdd :cente=0
            if z7=1 then fstart=fdd :cente=0
            if z8=1 then center=fdd :cente=1
            if z9=1 then span=fdd :cente=1
            aw="" 'on vide le buffer de caractere
            pmax=0 :if cal>2 then newcal=1 :cal=4
            goto finz6sub
        end if
        if z6=1 then locate 14,rep+12
        if z7=1 then locate 15,rep+12
        if z8=1 then locate 17,rep+12
        if z9=1 then locate 18,rep+12
        print "             "
        aw=""
        goto atenchar
    end if        
    if (l="K" or l="k") and val(aw)>0 then
        fdd=val(aw)*1000
        if fdd>15 and fdd<99999999.98 then
            if z6=1 then fstop=fdd :cente=0
            if z7=1 then fstart=fdd :cente=0
            if z8=1 then center=fdd :cente=1
            if z9=1 then span=fdd :cente=1
            aw="" 'on vide le buffer de caracteres
            pmax=0 :if cal>2 then newcal=1 :cal=4
            goto finz6sub
        end if
        if z6=1 then locate 14,rep+12
        if z7=1 then locate 15,rep+12
        if z8=1 then locate 17,rep+12
        if z9=1 then locate 18,rep+12
        print "             "
        aw=""
        goto atenchar
    end if                
    goto atenchar
    finz6sub:
    color 15,0
end sub        

sub help
    cls
    locate 2,ali+30 :color 14 :print "Help" :color 15
    locate 4,ali+1 :color 15
    print "To start or stop a scan, press the space-bar or use the start/stop button"
    locate 5,ali+1
    print "Choose between  - gain & phase ( insertion gain : dB scale & deg scale )"
    locate 6,ali+1
    print "                - gain & phase ( insertion gain : linear scale & deg scale )"
    locate 7,ali+1
    print "                - gain & delay ( insertion gain : dB scale & us scale )"
    locate 5,ali+19 : color 6 : print "gain & phase" 
    locate 6,ali+19 : color 6 : print "gain & phase"
    locate 7,ali+19 : color 6 : print "gain & delay" : color 15
    locate 8,ali+1
    print "Adjust the scales to your needs: "
    locate 8,ali+34 : color 6 : print "dB, U, deg, us, Hz" : color 15
    locate 8,ali+53 :print "(you can use k=kHz, m=MHz)"
    locate 9,ali+1 :print "Select the number of measurements per scan (meas/scan) : 51, 101, 201, 401, 801"
    locate 9,ali+45 :color 6 :print "meas/scan" :color 15
    locate 10,ali+1
    print "To measure delays : choose a delay aperture between 0.25% and 16% of the scan (the lower limit varies with meas/scan)"
    locate 10,ali+30 : color 6 :print "delay aperture" :locate 10,ali+108 :print "meas/scan" : color 15
    'locate 9,ali+1
    'print "To move the cursor across the menu, use the vertical arrows ";chr$(24);chr$(25)
    locate 11,ali+1
    print "To select between different possibilities, use the mouse buttons (left or right) or the mouse scroll wheel"
    locate 12,ali+1
    print "To change a number, put the mouse cursor on this number then type the new number + ""enter"""
    locate 13,ali+1
    print "To increment/decrement a digit of a number, put the mouse cursor on the digit, then move the mouse scroll wheel."
    locate 14,ali+1
    print "To move the markers, use the mouse"
    'locate 11,ali+13 :color c6 :print "markers" :color c15
    locate 15,ali+1
    print "To adjust the symmetry between the A input and the R input, use the adjustment button"
    locate 16,ali+1
    print "To normalize, select normalize: asked, then Start normalize"
    locate 16,ali+22 :color 6 : print "normalize: asked" :locate 16,ali+45 :print "Start normalize" :color 15
    locate 17,ali+1
    print "If normalize=on and if you change the sweep type (linear/log) or if you change the frequency scale then normalize=warning"
    locate 17,ali+105 :color 6 :print "normalize=warning"
    locate 18,ali+1 :color 15
    print "(the normalization is perhaps no more usable, if you don't know, it's safer to normalize again)"
    locate 19,ali+1 
    print "When you change the number of measurements per scan, the memory is cleared and the normalization is cleared"
'   locate 19,ali+17 :color 6 :print "meas/scan" :color 15
    locate 20,ali+1
    print "With display, you can choose to display only the gain (with or without Memory)"
    locate 20,ali+6 : color 6 : print "display" : color 15
    locate 21,ali+1
    print "With length(m) you can add (or remove) an electrical length to the R input (if normalize=off)"
    locate 21,ali+6 :color 6
    print "length(m)"
    locate 23,ali+1 :color 12
    print "Inputs and outputs are DC coupled, do not put DC voltage on inputs and outputs"
    locate 24,ali+1
    print "Do not exceed a maximun signal level of +7dBm on inputs A and R."
    locate 26,ali+1 :color 15
    print "To get a maximun dynamic range, put the signal at +6dBm"
    locate 27,ali+1
    print "To get precision , keep the signal under 0dBm and wait the stabilization of the"
    locate 28,ali+1
    print "temperature"
    locate 45,ali+1 :color 1
    print "Exit Help (Esc)" :color 15
    testclav:
    l=inkey$
    if asc(l,1)=27 then goto quitelp
    sleep 2
    getmouse x,y,wheel,bouton
    if x>(ali)*8 and x<(ali+16)*8 and y>(44*16) and  y<=(45*16)   then 
        if zzz5=0 then
            locate 45,ali+1 :color 0,1 :print "Exit Help (ESC)"
            zzz5=1 :color 15,0
        end if
    else
        if zzz5=1 then
            locate 45,ali+1 :color 1,0 :print "Exit Help (ESC)"
            zzz5=0 :color 15
        end if
    end if
    if zzz5=1 then                     'exit
        if bouton=1 and cleft=0 then
            goto quitelp
            cleft=1 :zzz5=0 
        end if
        if bouton=2 and cright=0 then
            goto quitelp
            cright=1 :zzz5=0 
        end if    
        if bouton=0 then
            cleft=0 :cright=0
        end if
    end if    
    goto testclav
    quitelp:
end sub

sub adjust
    cls
    locate 1,ali+20 :color 14
    print "Adjustment" :color 15
    locate 4,ali+2 :print "A/R Gain (U)        :"
    locate 5,ali+2 :print "A/R Phase (deg)     :"
    locate 6,ali+2 :print "clock frequency (Hz):"
    locate 7,ali+1 :color 6
    locate 8,ali+1
    print "A/R gain and phase adjustments are used to correct the bad symmetry between"
    locate 9,ali+1
    print "A and R inputs of the network analyzer. To do that : "
    locate 10,ali+1
    print "connect output A to input A and output R to input R, with short cables."
    locate 11,ali+1
    print "Now, with the F5 key, load the default values; and with the F4 key, save"
    locate 12,ali+1
    print "and exit."
    locate 13,ali+1
    print "At a frequency  about 1000 Hz, measure the gain(U) vs frequency (with "
    locate 14,ali+1
    print "normalize: off; length: 0.000m)."
    locate 15,ali+1
    print "The gain measured is the value that you have to write as A/R Gain in the"
    locate 16,ali+1
    print "adjustment screen; do the same for A/R phase."
    locate 17,ali+1
    print "Normally  0.8 < A/R gain < 1.2  and  -5deg < A/R phase < 5deg"
    locate 18,ali+1
    print "Prior to measuring the gain (U) vs frequency, wait the stabilization of the"
    locate 19,ali+1
    print "temperature."
    locate 23,ali+1
    print "note : with normalize=on, we can measure without A/R gain and phase adjustment"
    locate 24,ali+1
    print "With normalize=off , the precision of the measurement is greatly improved with "
    locate 25,ali+1
    print "A/R gain and phase adjustment."
    locate 26,ali+1
    print "Adjusment parameters are saved in a binary file named : configu"
    locate 21,ali+1
    print "The clock frequency (Hz) must be >149980000 and <150020000 (3*quartz frequency)"
    bobo="configu"
    ff=freefile
    open bobo for binary as #ff
    get #ff,3,gggain
    get #ff,7,ppphas
    get #ff,15,ccclock
    close #ff
    color 15
    locate 4,25+ali :print using "##.#######"; gggain
    locate 5,25+ali :print using "##.#######"; ppphas
    locate 6,26+ali :print using "#########";ccclock
    'gosub effasse
    'locate 28,1 :color 1 :print chr$(24);chr$(25);"Move"
    locate 45,ali+19 :color 1 :print "Load Default Values (F5)"
    locate 45,ali+1 :print "Exit (ESC)"
    locate 45,ali+52 :print "Save and Exit (F4)" :color 15
    zz2=0 :zz3=0 :zz4=0
    testcla:
    l=inkey$
    if l="" then goto testmouse
    if asc(l,1)=27 then goto quitconf
    if asc(l,2)=62 then goto saveexit
    if asc(l,2)=63 then
        gggain=defogain
        ppphas=defophas
        ccclock=defoclk
        locate 4,ali+25 :print using "##.#######"; gggain
        locate 5,ali+25 :print using "##.#######"; ppphas
        locate 6,ali+26 :print using "#########";ccclock
    end if
    testmouse:
    getmouse x,y,wheel,bouton
    
    if x>(ali)*8 and x<(ali+34)*8 and y>(3*16) and  y<=(4*16)   then  'A/R gain
        if zz2=0 then
            locate 4,ali+25 :color 0,15
            print using "##.#######";gggain 
            zz2=1 :color 15,0
        end if
    else
        if zz2=1 then
            locate 4,ali+25 :color 15,0
            print using "##.#######";gggain
            zz2=0
        end if
    end if
    if x>(ali)*8 and x<(ali+34)*8 and y>(4*16) and  y<=(5*16)   then  'A/R phase
        if zz3=0 then
            locate 5,ali+25 :color 0,15
            print using "##.#######";ppphas 
            zz3=1 :color 15,0
        end if
    else
        if zz3=1 then
            locate 5,ali+25 :color 15,0
            print using "##.#######";ppphas
            zz3=0
        end if
    end if
    if x>(ali)*8 and x<(ali+34)*8 and y>(5*16) and  y<=(6*16)   then  '150 MHz clock
        if zz4=0 then
            locate 6,ali+25 :color 0,15
            print using "##########";ccclock 
            zz4=1 :color 15,0
        end if
    else
        if zz4=1 then
            locate 6,ali+25 :color 15,0
            print using "##########";ccclock
            zz4=0
        end if
    end if
    if x>(ali)*8 and x<(ali+12)*8 and y>(44*16) and  y<=(45*16)   then 
        if zz5=0 then
            locate 45,ali+1 :color 0,1 :print "Exit (ESC)"
            zz5=1 :color 15,0
        end if
    else
        if zz5=1 then
            locate 45,ali+1 :color 1,0 :print "Exit (ESC)"
            zz5=0 :color 15
        end if
    end if
    if x>(ali+18)*8 and x<(ali+43)*8 and y>(44*16) and  y<=(45*16)   then  
        if zz6=0 then
            locate 45,ali+19 :color 0,1 :print "Load Default Values (F5)"
            zz6=1 :color 15,0
        end if
    else
        if zz6=1 then
            locate 45,ali+19 :color 1,0 :print "Load Default Values (F5)"
            zz6=0 :color 15
        end if
    end if
    if x>(ali+51)*8 and x<(ali+70)*8 and y>(44*16) and  y<=(45*16)   then  
        if zz7=0 then
            locate 45,ali+52 :color 0,1 :print "Save and Exit (F4)"
            zz7=1 :color 15,0
        end if
    else
        if zz7=1 then
            locate 45,ali+52 :color 1,0 :print "Save and Exit (F4)"
            zz7=0 :color 15
        end if
    end if
    if zz5=1 then                     'exit
        if bouton=1 and cleft=0 then
            goto quitconf
            cleft=1 :zz5=0 
        end if
        if bouton=2 and cright=0 then
            goto quitconf
            cright=1 :zz5=0 
        end if    
        if bouton=0 then
            cleft=0 :cright=0
        end if
    end if
    if zz7=1 then                     'save and exit
        if bouton=1 and cleft=0 then
            goto saveexit
            cleft=1 :zz7=0
        end if
        if bouton=2 and cright=0 then
            goto saveexit
            cright=1 :zz7=0
        end if    
        if bouton=0 then
            cleft=0 :cright=0
        end if
    end if
    if zz6=1 then                     'load default values
        if bouton=1 and cleft=0 then
            gggain=defogain
            ppphas=defophas
            ccclock=defoclk
            locate 4,ali+25 :print using "##.#######"; gggain
            locate 5,ali+25 :print using "##.#######"; ppphas
            locate 6,ali+26 :print using "#########";ccclock
            cleft=1 :z1=0 
        end if
        if bouton=2 and cright=0 then
            cright=1 :zz6=0 
        end if    
        if bouton=0 then
            cleft=0 :cright=0
        end if
    end if
    sleep 2
    if zz2>0 or zz3>0 or zz4>0 then goto pparici
    goto testcla
    pparici:
    if zz2=1 then
        if (bouton=1 and cleft=0) then
            color 0,14
            locate 4,ali+25 :print "_         "
            acquii=1 :bouton=0 
            goto ppx10
        end if
    end if    
    if zz3=1 then
        if (bouton=1 and cleft=0) then
            color 0,14
            locate 5,ali+25 :print "_         "
            acquii=1 :bouton=0 
            goto ppx10
        end if
    end if
    if zz4=1 then
        if (bouton=1 and cleft=0) then
            color 0,14
            locate 6,ali+25 :print "_         "
            acquii=1 :bouton=0 
            goto ppx10
        end if
    end if
    aw=""
    goto px10
    ppx10:
    l=inkey$
    sleep 2
    if l="" then goto ppx10
    if asc(l,1)=27 then goto quitconf
    l=left$(l,1)
    px10:
    if asc(l)>44 and asc(l)<58 and not(asc(l)=47) then
        if len(aw)<9 then
            acquii=1 :color 0,14
            aw=aw+l
            fdd=val(aw)
            if zz2=1 then locate 4,ali+25 :print "          " :locate 4,ali+25 :print aw
            if zz3=1 then locate 5,ali+25 :print "          " :locate 5,ali+25 :print aw
            if zz4=1 then locate 6,ali+25 :print "          "  :locate 6,ali+25 :print aw
        else
            goto ppx10
        end if
    end if
    if asc(l)=8 and acquii=1 then
        lu=len(aw)
        if lu>0 then lu=lu-1
            aw=left$(aw,lu)
            fdd=val(aw)
            if zz2=1 then locate 4,ali+25 :print "          " :locate 4,ali+25 :print aw
            if zz3=1 then locate 5,ali+25 :print "          " :locate 5,ali+25 :print aw
            if zz4=1 then locate 6,ali+25 :print "          "  :locate 6,ali+25 :print aw
        end if
        if asc(l)=13  and acquii=1 then
            if zz2=1 then
                if fdd>0.799 and fdd<1.2001 then
                    aw="" :gggain=fdd :locate 4,ali+25 :print using "##.#######";fdd
                     acquii=0 :zz2=0 :color 0,15
                    goto testcla
                end if
                aw="" :locate 4,ali+25 :print "          "
                goto ppx10
            end if
            if zz3=1 then
            if fdd>-5.001 and fdd<5.001 then
                aw="" :ppphas=fdd :locate 5,ali+25 :print using "##.#######";fdd  
                acquii=0 :zz3=0 :color 0,15
                goto testcla
            end if
            aw="" :locate 5,ali+25 :print "          "
            goto ppx10
        end if
        if zz4=1 then
        if fdd>149980000 and fdd<150020000 then
            aw="" :ccclock=fdd :locate 6,ali+25 :print using "##########";fdd
            acquii=0 :zz4=0 :color 0,15
            goto testcla
        end if
        aw="" :locate 6,ali+25 :print "          "
        goto ppx10
        end if
    end if
    if acquii=1 then goto ppx10
    if acquii=0 then goto testcla
    saveexit:
    bobo="configu"
    ff=freefile
    open bobo for binary as #ff
    put #ff,3,gggain
    put #ff,7,ppphas
    put #ff,15,ccclock
    ggain=gggain
    pphas=ppphas
    cclock=ccclock
    close #ff
    quitconf:
    cls
end sub

sub savefile
   
    sauvpo=0
    acqi=0
    choi=1 ' 1 pour s2p(s21), 2 pour s2p(s12), 3 pour BMP
    cls           
    zz1=0 :zz2=0 :zz3=0 :zz4=0
    locate 5,5 : print "Save As"
    locate 8,10 : print "file name :"
    locate 10,10 : print "     type :"
    locate 10,22 : print " s2p(s21) "
    locate 12,22 : print "  save    "

    locate 8,22  : print " noname "
    copynom="noname"
    'line (164,112)-(254,127),c14,b

    locate 19,3 : color 6
    print "s21 = forward insertion gain"
    locate 20,3
    print "s12 = reverse insertion gain"
    locate 21,3 : color 6
    print "s2p file is used to save the parameters of a two ports device"
    locate 22,3
    print "BMP file is used to get a copy of the measurement screen"
    locate 24,3
    print "If the file xxxxxxxx.s2p already exists, then the parameter (s21 or s12) is"
    locate 25,3
    print "added to the existing file ."
    color 15
    locate 45,ali+2 :color 1
    print "Exit (Esc)"

    testecla:
    l=inkey$
    sleep 2
    if l="" then goto testmouse
    if asc(l,1)=27 then
        goto finsubsavefile
    end if
    testmouse:
    getmouse x,y,wheel,bouton
    if x>(ali)*8 and x<(ali+60)*8 and y>(7*16) and  y<=(8*16)   then  'file name
        if zz1=1 then
            if (bouton=1 and cleft=0) then
                locate 8,ali+20 :color 0,14
                print "_                                        "
                cleft=1 
            end if
            if bouton=0 then cleft=0
        end if
        if zz1=0 then
            locate 8,ali+20 :color 0,15
            if len(copynom)<41 then
                copinom=copynom
                while len(copinom)<41
                    copinom=copinom+" "
                wend
                print copinom
            else
                print copynom
            end if
            zz1=1 :color 15,0
        end if
    else
        if zz1=1 then
            locate 8,ali+20 :color 15,0
            if len(copynom)<41 then
                copinom=copynom
                while len(copinom)<41
                    copinom=copinom+" "
                wend
                print copinom
            else
                print copynom
            end if            
            'print copynom
            zz1=0
        end if
    end if
    if x>(ali)*8 and x<(ali+30)*8 and y>(9*16) and  y<=(10*16)   then  'type
        if zz2=0 then
            locate 10,ali+20 :color 0,15
            if choi=1 then print " s2p (s21)"
            if choi=2 then print " s2p (s12)"
            if choi=3 then print "  BMP     "
            zz2=1 :color 15,0
        end if
    else
        if zz2=1 then
            locate 10,ali+20 :color 15,0
            if choi=1 then print " s2p (s21)"
            if choi=2 then print " s2p (s12)"
            if choi=3 then print "  BMP     "
            zz2=0
        end if
    end if
    if x>(ali)*8 and x<(ali+30)*8 and y>(11*16) and  y<=(12*16)   then  'save
        if zz3=0 then
            locate 12,ali+20 :color 0,15
            print "save     " 
            zz3=1 :color 15,0
        end if
    else
        if zz3=1 then
            locate 12,ali+20 :color 15,0
            print "save     " 
            zz3=0
        end if
    end if
    if x>(ali)*8 and x<(ali+12)*8 and y>(44*16) and  y<=(45*16)   then 'Exit
        if zz4=0 then
            locate 45,ali+2 :color 0,1 :print "Exit (ESC)"
            zz4=1 :color 15,0
        end if
    else
        if zz4=1 then
            locate 45,ali+2 :color 1,0 :print "Exit (ESC)"
            zz4=0 :color 15
        end if
    end if
    
    if zz4=1 then                     'exit
        if bouton=1 and cleft=0 then
            goto finsubsavefile
            cleft=1 :zz4=0 
        end if
        if bouton=2 and cright=0 then
            goto finsubsavefile
            cright=1 :zz4=0 
        end if    
        if bouton=0 then
            cleft=0 :cright=0
        end if
    end if
    if zz3=1 then
        if bouton=1 and cleft=0 then
            if choi=1 then
                bobo=copynom + ".s2p"
                xistdja=dir$(bobo)
                if xistdja="" then
                    s2ps21()
                else 
                    ss2112=0 'pour dire que c'est s21 que l'on va ecrire
                    s2112dja()
                end if
                goto finsubsavefile
            end if
            if choi=2 then
                bobo=copynom + ".s2p"
                xistdja=dir$(bobo)
                if xistdja="" then
                    s2ps12()
                else 
                    ss2112=1 ' pour dire que c'est s12 que l'on va ecrire
                    s2112dja()
                end if 
                goto finsubsavefile
            end if
            if choi=3 then
                bmpecri=1
                goto finsubsavefile
            end if
            if bouton=0 then
                cleft=0 :cright=0
            end if
        end if
    end if
    if zz2=1 then
        if bouton=1 and cleft=0 then
            choi=choi+1
            if choi=4 then choi=1
            cleft=1 :zz2=0
        end if
        if bouton=2 and cright=0 then
            choi=choi-1
            if choi=0 then choi=3
            cright=1 :zz2=0
        end if
        if bouton=0 then cleft=0 :cright=0
    end if

    l=left$(l,1)
    ll=asc(left$(l,1))
    if zz1=1 and ((ll>47 and ll<58) or (ll>64 and ll<91) or ll=95 or (ll>96 and ll<123)) then
        locate 8,23 :color 0 :print "                                         "
        goto typefilename
        'goto py10
        ppy10:
        l=inkey$
        sleep 10
        if l="" then goto ppy10
        if asc(l,1)=27 then
            goto finsubsavefile
        end if
        py10:
        l=left$(l,1)
        ll=asc(left$(l,1))
        if (ll>47 and ll<58) or (ll>64 and ll<91) or ll=95 or (ll>96 and ll<123) then
            typefilename:   
            if len(aw)<41 then
                acqi=1 :aw=aw+l
                locate 8,23 :color 0,14 
                print "                                         " 
                locate 8,23  :print aw
            end if
        end if
        if asc(l)=8 then
            lu=len(aw)
            if lu>0 then lu=lu-1
            aw=left$(aw,lu)
            locate 8,23 :color 0,14 
            print "                                         " 
            locate 8,23 :print aw
        end if
        if asc(l)=13 then
            if aw="" then
                aw=copynom
                locate 8,23 :color 0,15
                print "                                         "
                locate 8,23 :print copynom
                sleep 200
            else
                copynom=aw :locate 8,23 :color 0,15
                print "                                         "
                locate 8,23
                print copynom
                color 15,0
                line (1,29*16)-(1020,35*16),0,bf
                bubu=copynom + ".bmp"
                xist1=dir$(bubu)
                if xist1="" then
                else
                    locate 32,5 :print "The file ";bubu;" already exists"
                    locate 33,5 :print "If you save as ""bmp"", then the file will be overwritten."
                end if
                bubu=copynom + ".s2p"
                xist1=dir$(bubu)
                if xist1="" then
                else
                    locate 34,5 :print "The file ";bubu;" already exists"
                    locate 35,5 :print "If you save as ""s2p(s21) or s2p(s12)"", then the data (s21 or s12) will be added to the file."
                end if                 
            end if
            aw="" :acqi=0
            goto testecla
        end if
        if acqi=0 then goto testecla
        goto ppy10
    end if
    goto testecla
    finsubsavefile:
    cls
end sub


sub efasse
    line (164,112)-(254,127),0,b
    line (164,144)-(254,159),0,b
    line (164,176)-(254,191),0,b
    if sauvpo=0 then line (164,112)-(254,127),14,b
    if sauvpo=1 then line (164,144)-(254,159),14,b
    if sauvpo=2 then line (164,176)-(254,191),14,b
end sub

sub ecribmp
    fb=freefile
    bobo=copynom + ".bmp"
    open bobo for binary as #fb
    deuxbyte=&h0000 
    for i=1 to 31 'to reset the beginning of the bmp file
        put #fb,i*2,deuxbyte
    next i
    deuxbyte=&h4d42 '"BM"
    put #fb,1,deuxbyte
    quatrebyte=&hc0437 'file size
    put #fb,&h0003,quatrebyte
    quatrebyte=&h0436 'offset of the bitmap data
    put #fb,&h000b,quatrebyte
    quatrebyte=&h0028 'size of info header
    put #fb,&h000f,quatrebyte
    quatrebyte=&h0400 'bitmap width
    put #fb,&h0013,quatrebyte
    quatrebyte=&h300 'bitmap height
    put #fb,&h0017,quatrebyte
    deuxbyte=&h0001 'number of plane (=1)
    put #fb,&h001b,deuxbyte
    deuxbyte=&h0008 'bits per pixel
    put #fb,&h001d,deuxbyte
    quatrebyte=&h0000 'type of compression
    put #fb,&h001f,quatrebyte
    quatrebyte=&h0100 'number of colors
    put #fb,&h002f,quatrebyte
    put #fb,&h0033,quatrebyte 'number of important colors
    for i=0 to 255
        palette get i,rouge,vert,bleu
        zero=0 :red=rouge :green=vert :blue=bleu
        put #fb,,blue  'to write the palette
        put #fb,,green
        put #fb,,red
        put #fb,,zero
    next i
    for i=767 to 0 step -1
        ligne=""
        for k=0 to 1023
            pixel=point(k,i)
            ligne=ligne+chr(pixel)
        next k
        put #fb,,ligne
    next i
    close #fb
end sub


sub s2ps21
    while  len(titre) < 29 
        titre = titre + " "
    wend
    mxxx="!  anareso  " + titre + chr$(13) + chr$(10)
    mxxx=mxxx + "! parameter S" + chr$(13) + chr$(10) +"# HZ S DB R 50" + chr$(13) + chr$(10)
    bobo=copynom + ".s2p" 
    fff=freefile
    open bobo for binary as #fff
    close #fff
    kill bobo
    open bobo for binary as #fff
    put #fff,0,mxxx
    for i=0 to nb-1
    s21s12()
    dxxx=str(frec) +" 0.0 0.0 " + str(Axx)+" " +str(T1xx)
    dxxx=dxxx+ " 0.0 0.0 0.0 0.0 "+ chr$(13) + chr$(10)
    put #fff,,dxxx
    next i
    close #fff
end sub

sub s2ps12
    while len(titre) < 29 
        titre = titre + " "
    wend
    mxxx="!  anareso  " + titre + chr$(13) + chr$(10)
    mxxx=mxxx + "! parameter S" + chr$(13) + chr$(10) +"# HZ S DB R 50" + chr$(13) + chr$(10)
    bobo=copynom + ".s2p"
    fff=freefile
    open bobo for binary as #fff
    close #fff
    kill bobo
    open bobo for binary as #fff
    put #fff,0,mxxx
    for i=0 to nb-1
        s21s12()
        dxxx=str(frec) +" 0.0 0.0 0.0 0.0 " + str(Axx)+" " + str(T1xx)
        dxxx=dxxx+ " 0.0 0.0 "+ chr$(13) + chr$(10)
        put #fff,,dxxx
    next i
    close #fff
end sub

sub s21s12
    if linlog=1 then
        frec=(10^(log(fstop/fstart)/log(10)*i/(nb-1))*fstart)
    else
        frec=((fstop-fstart)*i/(nb-1)+fstart)
    end if
    if cal < 3 then
        Axx=20*log(sqr(w3L(i)^2 + z3L(i)^2))/log(10)
        T1xx=atan2(z3L(i),w3L(i))
        T1xx=T1xx*(180/pi)
    end if
    if (cal=3 or cal=4) then
        Axx=20*log(sqr(wnd(i)^2 + znd(i)^2))/log(10)
        T1xx=atan2(znd(i),wnd(i))
        T1xx=T1xx*(180/pi)
    end if
end sub

sub s2112dja

    'lecture du fichier s2p et eciture de spartemp.tmp

    c="" 'caractere lut dans le fichier s1p
    esclam=0 'esclam=1 si on a lut un "!" en debut de ligne
    diese=0  'diese=1  on  lit la ligne du "#" 
          'diese=2 (ou plus) = on a deja lut la ligne du diese
    kk="" 'chaine de caractere d'une ligne max pour recopier de bibi dans baba 
    done = 0 'on n'a pas encore ecrit la frquence    
    'done = 1 'on ecrit la frequence
    'done = 2 'on a fini d'ecrire la frequence
    'done = 3 'on ecrit le module de s11 en dB
    'done = 4 'on a fini d'ecrire le module de s11
    'done = 5 'on ecrit la phase de s11
    'done = 6 'on a fini d'ecrire la phase de s11
    'done = 7 'on ecrit le module de s21
    'done = 8 'on a fini d'ecrire le module de s21
    'done = 9 'on ecrit la phase de s21
    'done = 10 'on a fini d'ecrire la phase de s21
    'done = 11 'on ecrit le module de s12
    'done = 12 'on a fini d'ecrire le module de s12
    'done = 13 'on ecrit la phase de s12
    'done = 14 'on a fini d'ecrire la phase de s12
    'done = 15 'on ecrit le module de s22
    'done = 16 'on a fini d'ecrire le module de s22
    'done = 17 'on ecrit la phase de s22
    'done = 18 'on a fini d'ecrire la phase de s22
    nbb=0 'numero de la frequence varie de 0 a nb-1
    freqq="" 'pour ecrire la frequence
    ms11=""  'pour ecrire le module de s11
    as11=""  'pour ecrire la phase de s11 

    bibi=copynom + ".s2p"
    fff=freefile
    open bibi for binary as #fff 
    taille = lof(fff)
    baba="spartemp.tmp"
    ff2=freefile
    open baba for binary as #ff2


    bcl1:    'boucle de lecture du fichier s2p
    if taille = loc(fff) then goto finrcopi
    get #fff,,c
    if ss2112=0 and (done <6 or done >9) then
        kk=kk + c
    end if
    if ss2112=1 and (done <10 or done >13) then
        kk=kk + c
    end if
    if esclam=1 then
        if c=chr$(10) then
            esclam=0
            put #ff2,,kk
            kk="" 
        end if
        goto bcl1
    end if
    if diese=1 then 'mettre ici la lecture des formats
        if c=chr$(10) then
            put #ff2,,kk
            kk="" 
            diese=2
        end if 
        goto bcl1
    end if
    if c="!" then esclam=1
    if c="#" then diese=diese + 1
    if c=" " then
        if done =5 and ss2112=0 then
            i=nbb
            s21s12()
            kk=kk+ str(Axx) + " " +  str(T1xx) + " "
        end if
        if done =9 and ss2112=1 then
            i=nbb
            s21s12()
            kk=kk + str(Axx) + " " +  str(T1xx) + " "
        end if 
        if done mod 2 = 1 then done = done + 1 ' si done est impair on l'incremente
    end if
    if (asc(c)>42 and asc(c)<58 and not(asc(c)=47)) or c="E" or c="e" then
        if diese = 0  or diese > 2 then goto erreur
        if done mod 2 = 0 then done = done + 1
    end if
    if c=chr$(10) then
        if (done > 0 and done < 17) or done >18  then goto erreur
        if done = 17 then
            done = 0
            put #ff2,,kk
            kk="" 
        end if 
        if done = 18 then
            done=0
            put #ff2,,kk
            kk="" 
        end if
        if nbb < (nb-1) then
            nbb = nbb + 1
        else
            goto finrcopi
        end if
    end if
    goto bcl1

    erreur:
    locate 5,5
    print " error : the file is not compatible "
    sleep 4000
    close #fff
    close #ff2
    goto findjasub

    finrcopi:
    close #fff
    close #ff2
    kill bibi
    NAME baba AS bibi
    findjasub:
end sub
sub wheel1
    kz=0
    if x<(rep+24)*8 then kz=0.00001
    if x<(rep+23)*8 then kz=0.0001
    if x<(rep+22)*8 then kz=0.001
    if x<(rep+21)*8 then kz=0.01
    if x<(rep+20)*8 then kz=0.1
    if x<(rep+18)*8 then kz=1
    if x<(rep+17)*8 then kz=10
    if x<(rep+16)*8 then kz=100
    if x<(rep+15)*8 then kz=1000
    if x<(rep+14)*8 then kz=10000
    if x<(rep+13)*8 then kz=100000
    if x<(rep+12)*8 then kz=1000000
    if x<(rep+19)*8 and x>=(rep+18)*8 then kz=0
end sub

sub wheel2
    kz=0
    if x<(rep+24)*8 then kz=0.01
    if x<(rep+23)*8 then kz=0.1
    if x<(rep+21)*8 then kz=1
    if x<(rep+20)*8 then kz=10
    if x<(rep+19)*8 then kz=100
    if x<(rep+18)*8 then kz=1000
    if x<(rep+17)*8 then kz=10000
    if x<(rep+16)*8 then kz=100000
    if x<(rep+15)*8 then kz=1000000
    if x<(rep+14)*8 then kz=10000000
    if x<(rep+22)*8 and x>=(rep+21)*8 then kz=0
end sub

sub setport
    cls
    locate 5,40 :color 14
    print "Serial Port Setting"
    locate 8,46 :color 15
    print "COM :   "
    locate 20,5 :color 6
    print "Within Windows menus : Device Manager | Port Settings | " 
    locate 21,5
    print "find the USB Serial Port COM address of the FTDI USB Serial Converter"
    locate 23,5
    print "Write this COM port Address in this menu, then Save & Exit "
    locate 45,ali+1 :color 1 :print "Exit (ESC)"
    locate 45,ali+52 :print "Save and Exit (F4)" :color 15
    bobo="configu"
    ff=freefile
    open bobo for binary as #ff
    get #ff,1,usbcomm
    close #ff
    color 0,15
    locate 8,52  :print usbcomm
    color 15
    zz2=0 :zz3=0 :zz4=0
    testcla:
    color 15,0
    l=inkey$
    if l="" then goto testmouse
    if asc(l,1)=27 then goto quitsetport
    if asc(l,2)=62 then goto saveexit
    l=left$(l,1)
    if asc(l)>48 and asc(l)<58  then
        usbcomm=val(l)
        locate 8,52 :color 0,15 :print usbcomm
    end if
    testmouse:
    getmouse x,y,wheel,bouton
    if x>(ali)*8 and x<(ali+12)*8 and y>(44*16) and  y<=(45*16)   then 
        if zz5=0 then
            locate 45,ali+1 :color 0,1 :print "Exit (ESC)"
            zz5=1 :color 15,0
        end if
    else
        if zz5=1 then
            locate 45,ali+1 :color 1,0 :print "Exit (ESC)"
            zz5=0 :color 15
        end if
    end if
    if x>(ali+51)*8 and x<(ali+70)*8 and y>(44*16) and  y<=(45*16)   then  
        if zz7=0 then
            locate 45,ali+52 :color 0,1 :print "Save and Exit (F4)"
            zz7=1 :color 15,0
        end if
    else
        if zz7=1 then
            locate 45,ali+52 :color 1,0 :print "Save and Exit (F4)"
            zz7=0 :color 15
        end if
    end if    
    if zz5=1 then                     'exit
        if bouton=1 and cleft=0 then
            goto quitsetport
            cleft=1 :zz5=0 
        end if
        if bouton=2 and cright=0 then
            goto quitsetport
            cright=1 :zz5=0 
        end if    
        if bouton=0 then
            cleft=0 :cright=0
        end if
    end if
    if zz7=1 then                     'save and exit
        if bouton=1 and cleft=0 then
            goto saveexit
            cleft=1 :zz7=0
        end if
        if bouton=2 and cright=0 then
            goto saveexit
            cright=1 :zz7=0
        end if    
        if bouton=0 then
            cleft=0 :cright=0
        end if
    end if
    sleep 3
    goto testcla
    saveexit:
    bobo="configu"
    ff=freefile
    open bobo for binary as #ff
    put #ff,1,usbcomm
    close #ff
    usbcom=usbcomm
    quitsetport:
end sub



f=freefile
open bobo for binary as #f
if lof(f) <>26 then
    close #f
    kill bobo
    open bobo for binary as #f
    put #f,1,defousbcom
    put #f,3,defogain
    put #f,7,defophas
    put #f,11,deforef
    put #f,15,defoclk
    put #f,19,defolref
    put #f,23,defocref
'    locate 10,10 :print lof(f) :sleep 3000
end if
get #f,1,usbcom 'adresse du port com (usb)
get #f,3,ggain 'gain entre l'entre A et l'entree R
get #f,7,pphas 'dephasage entre l'entree A et l'entree R
get #f,15,cclock 'cclock=3* frequence du quartz
close #f

locate 6,38 :print " A Network Analyzer program "
locate 18,34 :print "To measure Filters and Amplifiers"
locate 45,5 :print "F2: Setup"

for i=0 to 80
    l=inkey$
    if asc(l,2)=60 then setport()
    sleep 30
next i



menu()
dessin1()
markers()
dessin2()


f=FreeFile
locate 10,20 :color 0,15
portcom="COM" + str(usbcom) + ":57600,N,8,1,CS0,DS0,BIN,CD0"
Open com portcom for binary As #f
'Open Com "/dev/ttyUSB0: 57600,N,8,1,CS0,DS0,BIN,CD0"for binary As #f
'Open Com "COM3:57600,N,8,1,BIN,CS0,DS0"for binary As #f
'Open Com "/dev/ttyUSB0: 57600, N, 8, 1,DT ,BIN"for binary As #f
'Open Com "/dev/ttyUSB0: 57600, N, 8, 1, RS,BIN"for binary As #f
If Err>0 Then Print "USB port could not be opended"
color 15,0
sleep 1500

'enable serial load

bid=128 : put #f, ,bid
bid=&h4 or 128 : put #f, ,bid
bid=128 : put #f, ,bid
for i=0 to 7
    bid=&h2 or 128 : put #f, ,bid
    bid=128 : put #f, ,bid
next i
bid=(&h4 or 128) : put #f, ,bid
bid=128 : put #f, ,bid
sleep 10

'synchroniser les ADC
plouf=160
put #f, ,plouf
sleep 50
pmax=0

parici:


for p=0 to nb-1
if linlog=1 then
    'freq(p)=10^((log(fstop/fstart)/log(10))*p/400)*fstart
    freq(p)=10^((log(fstop/fstart)/log(10))*p/(nb-1))*fstart
else
    freq(p)=(fstop-fstart)*p/(nb-1)+fstart
end if
next p
p=pmax
ef=0

freq(nb)=freq(0)
freq(nb+1)=freq(1)
frequence()
bid=(&h4 or 128) 'pulse sur FQ_UD
put #f, ,bid
bid=128
put #f, ,bid
sleep 20
p=p+1
frequence()
p=p-1
sleep 20

parla:
zute1=timer
if p=0 then sleep 10 ' a verifier ,delai supplementaire sur le premier point de la courbe
acqui()
if usberror=1 then
    va=0 :if cal<3 then cal=0
    locate 36,rep+2
    print " Start  "
    close #f
    locate 31,rep+2 :color 0,6
    print " Error: USB timeout   "
    locate 32,rep+2 
    print " USB Reset : wait (3s)"
    sleep 1200
    f=FreeFile
    Open com portcom for binary As #f
    'Open com "COM4:57600,N,8,1,CS0,DS0,BIN,CD0"for binary As #f
    'Open Com "/dev/ttyUSB0: 57600,N,8,1,CS0,DS0,BIN,CD0"for binary As #f
    'Open Com "COM3:57600,N,8,1,BIN,CS0,DS0"for binary As #f
    'Open Com "/dev/ttyUSB0: 57600, N, 8, 1,DT ,BIN"for binary As #f
    'Open Com "/dev/ttyUSB0: 57600, N, 8, 1, RS,BIN"for binary As #f
    If Err>0 Then
        locate 31,rep+2
        Print " USB port             " 
        locate 32,rep+2
        print " could not be opended "
    else
        sleep 1600
        locate 31,rep+2
        print " Try to scan again    "
        locate 32,rep+2
        print " if it fails :        "
        locate 33,rep+2
        print " try to restart the PC"
    end if
    color 15,0
    goto boucle
end if
  
zute2=timer
if abort=1 then
    abort=0
    va=0
    markers()
    dessin2()
    refresh=0 :z1=0 :z2=0 :z3=0 :z4=0 :z5=0 :z6=0 :z7=0 :z8=0 :z9=0 :z10=0 :z11=0
    z12=0 :z13=0 :z14=0 :z15=0 :z16=0 :z17=0 :z18=0
    z22=0 :z23=0 :z24=0 :z25=0
    goto boucle
end if

getmouse x,y,wheel,bouton
if z22=1 then 'bouton start
    if bouton=1 and cleft=0 then
        va=0 :stoprequest=0
        if cal=2 then
            cal=0
            locate 20,20 :color 0,15 :print " Normalization aborted "
            sleep 2000 :color 15,0
        end if
       'p=pmax
        menu()
        dessin1()
        markers()
        dessin2()
        cleft=1 :z22=0 :zq22=0
        refresh=0 :z1=0 :z2=0 :z3=0 :z4=0 :z5=0 :z6=0 :z7=0 :z8=0 :z9=0 :z10=0 :z11=0
        z12=0 :z13=0 :z14=0 :z15=0 :z16=0 :z17=0 :z18=0
        z22=0 :z23=0 :z24=0 :z25=0 :zq22=0        
        goto boucle
    end if
    if bouton=0 then cleft=0
end if
color 15

l=inkey$
if l=" " or stoprequest=1 then
    va=0 :stoprequest=0
    if cal=2 then
        cal=0
        locate 20,20 :color 0,15 :print " Normalization aborted "
        sleep 2000 :color 15,0
    end if
    menu()
    dessin1()
    markers()
    dessin2()
    refresh=0 :z1=0 :z2=0 :z3=0 :z4=0 :z5=0 :z6=0 :z7=0 :z8=0 :z9=0 :z10=0 :z11=0
    z12=0 :z13=0 :z14=0 :z15=0 :z16=0 :z17=0 :z18=0
    z22=0 :z23=0 :z24=0 :z25=0 :zq22=0
    goto boucle
end if
if l="" then goto pluloin
if asc(l,1)=27 then goto sortie

pluloin:

bid=(&h4 or 128) 'pulse sur FQ_UD
put #f, ,bid
bid=128
put #f, ,bid
'time9=time1
time1=timer

calcul()
screencopy 2,1
markers()
dessin2()
pmax=p
p=p+1 
if p=nb then
    p=0 :complet=1
    if cal=2 then
        cal=3':locate 25,rep+2 :print "normalize: on   "
        locate 20,20 :color 0,15 :print "normalization: done"
        locate 25,rep+2 :color 15,0 :print "normalize: on     "        
        color 15,0 :sleep 1900 :menu() :dessin1()
    end if
end if

p=p+1
frequence()
p=p-1

time3=timer
while (timer-time1)*1000 <24 
    sleep 15 '30
wend

while (timer-time1)*1000<37 
    sleep 0.3
wend

goto parla


boucle:

getmouse x,y,wheel,bouton
color 15

if z1=1 then                     'change the main choice
    if bouton=1 and cleft=0 then
        ti=ti+1 :if ti=3 then ti=0
        cleft=1 :z1=0 :refresh=1
    end if
    if bouton=2 and cright=0 then
        ti=ti-1 :if ti=-1 then ti=2
        cright=1 :z1=0 :refresh=1
    end if    
    if bouton=0 then
        cleft=0 :cright=0
    end if
    if wheel>roue1 and y>8 then
       ti=ti+1 :if ti=3 then ti=0
       z1=0 :refresh=1 :sleep 100 :roue1=wheel
    end if
    if wheel<roue1 and y>8 then
        ti=ti-1 :if ti=-1 then ti=2
        z1=0 :refresh=1 :sleep 100 :roue1=wheel
    end if
else
    roue1=wheel
end if
if y<8 then roue1=wheel
if z2=1 then   'pour editer gain max                      
    if (bouton=1 and cleft=0) then
        locate 6,rep+12 :color 0,14
        print "_            "
        color 15,0
        z2sub() :verif()
        if sort=1 then goto sortie
        cleft=1 :z2=0 :refresh=1
    end if
    if bouton=0 then cleft=0
    if wheel<roue2 or wheel>roue2 then
        wheel1()
        if wheel<roue2 then kz=-kz
        if maax(ti)+kz<9999999.98 and maax(ti)+kz>-999999.99 and maax(ti)+kz>miin(ti) then
            maax(ti)=maax(ti)+kz
            sleep 100
            z2=0 :refresh=1
        end if
        roue2=wheel
    end if
else
    roue2=wheel
end if
if z3=1 then   'pour editer gain min                      
    if (bouton=1 and cleft=0) then
        locate 7,rep+12 :color 0,14
        print "_            "
        color 15,0
        z2sub() :verif()
        if sort=1 then goto sortie
        cleft=1 :z3=0 :refresh=1
    end if
    if bouton=0 then cleft=0
    if wheel<roue3 or wheel>roue3 then
        wheel1()
        if wheel<roue3 then kz=-kz
        if miin(ti)+kz<9999999.98 and miin(ti)+kz>-999999.99 and miin(ti)+kz<maax(ti) then
            miin(ti)=miin(ti)+kz
            sleep 100
            z3=0 :refresh=1
        end if
        roue3=wheel
    end if
else
    roue3=wheel   
end if
if z4=1 then 'pour editer phase (delay) max
    if (bouton=1 and cleft=0) then
        locate 10,rep+12 :color 0,14
        print "_            "
        color 15,0
        z4sub() :verif()
        if sort=1 then goto sortie
        cleft=1 :z4=0 :refresh=1
    end if
    if bouton=0 then cleft=0
    if wheel<roue4 or wheel>roue4 then
        wheel1()
        if wheel<roue4 then kz=-kz
        if maxa(ti)+kz<9999999.98 and maxa(ti)+kz>-999999.99 and maxa(ti)+kz >mina(ti) then
            maxa(ti)=maxa(ti)+kz
            sleep 100
            z4=0 :refresh=1
        end if
        roue4=wheel
    end if
else
    roue4=wheel   
end if
if z5=1 then 'pour editer phase (delay) min
    if (bouton=1 and cleft=0) then
        locate 11,rep+12 :color 0,14
        print "_            "
        color 15,0
        z4sub() :verif()
        if sort=1 then goto sortie
        cleft=1 :z5=0 :refresh=1
    end if
    if bouton=0 then cleft=0
    if wheel<roue5 or wheel>roue5 then
        wheel1()
        if wheel<roue5 then kz=-kz
        if mina(ti)+kz<9999999.98 and mina(ti)+kz>-999999.99 and mina(ti)+kz<maxa(ti) then
            mina(ti)=mina(ti)+kz
            sleep 100
            z5=0 :refresh=1
        end if
        roue5=wheel
    end if
else
    roue5=wheel   
end if
if z6=1 then   'pour editer fstop                      
    if (bouton=1 and cleft=0) then
        locate 14,rep+12 :color 0,14
        print "_            "
        color 15,0
        z6sub() :verif()
        if sort=1 then goto sortie
        menu()
        dessin1()
        markers()
        dessin2()
        cleft=1 :z6=0
    end if
    if bouton=0 then cleft=0
    if wheel<roue6 or wheel>roue6 then
        wheel2()
        if wheel<roue6 then kz=-kz
        if fstop+kz<99999999.99 and fstop+kz>5 and fstop+kz>fstart then
            fstop=fstop+kz :sleep 100 :z6=0 :pmax=0 
            complet=0 :m1m2=0 :p=0 :ef=1 :cente=0
            if cal>2 then newcal=1 :cal=4
            verif() :menu() :dessin1() :markers :dessin2()
        end if
        roue6=wheel
    end if
else
    roue6=wheel
end if
if z7=1 then  'pour editer fstart
    if (bouton=1 and cleft=0) then
        locate 15,rep+12 :color 0,14
        print "_            "
        color 15,0
        z6sub() :verif()
        if sort=1 then goto sortie
        menu()
        dessin1()
        markers()
        dessin2()
        cleft=1 :z7=0
    end if
    if bouton=0 then cleft=0
    if wheel<roue7 or wheel>roue7 then
        wheel2()
        if wheel<roue7 then kz=-kz
        if fstart+kz<99999999.98 and fstart+kz>5 and fstart+kz<fstop then
            fstart=fstart+kz :sleep 100 :z7=0 :pmax=0 
            complet=0 :m1m2=0 :p=0 :ef=1 :cente=0
            if cal>2 then newcal=1 :cal=4
            verif() :menu() :dessin1() :markers :dessin2()
        end if
        roue7=wheel
    end if
else
    roue7=wheel
end if
if z8=1 then   'pour editer center                      
    if (bouton=1 and cleft=0) then
        locate 17,rep+12 :color 0,14
        print "_            "
        color 15,0
        z6sub() :verif()
        if sort=1 then goto sortie
        menu()
        dessin1()
        markers()
        dessin2()
        cleft=1 :z8=0
    end if
    if bouton=0 then cleft=0
    if wheel<roue8 or wheel>roue8 then
        wheel2()
        if wheel<roue8 then kz=-kz
        if center+kz+span/2<99999999.98 and center+kz-span/2>10 then
            center=center+kz :sleep 100 :z8=0 :pmax=0 
            complet=0 :m1m2=0 :p=0 :ef=1 :cente=1
            if cal>2 then newcal=1 :cal=4
            verif() :menu() :dessin1() :markers :dessin2()
        end if
        roue8=wheel
    end if
else
    roue8=wheel    
end if
if z9=1 then  'pour editer span
    if (bouton=1 and cleft=0) then
        locate 18,rep+12 :color 0,14
        print "_            "
        color 15,0
        z6sub() :verif()
        if sort=1 then goto sortie
        menu()
        dessin1()
        markers()
        dessin2()
        cleft=1 :z9=0
    end if
    if bouton=0 then cleft=0
    if wheel<roue9 or wheel>roue9 then
        wheel2()
        if wheel<roue9 then kz=-kz
        if (span+kz)/2+center<99999999.98 and center-(span+kz)/2>10 then
            span=span+kz :sleep 100 :z9=0 :pmax=0 
            complet=0 :m1m2=0 :p=0 :ef=1 :cente=1
            if cal>2 then newcal=1 :cal=4
            verif() :menu() :dessin1() :markers :dessin2()
        end if
        roue9=wheel
    end if
else
    roue9=wheel        
end if
if z10=1 then                       'toggle linear/log
    if (bouton=1 and cleft=0) then
        if linlog=0 then 
            linlog=1
        else
            linlog=0
        end if
        ef=1 :newcal=1 :p=0
        menu()
        dessin1()
        markers()
        dessin2()
        cleft=1 :z10=0
    end if
    if (bouton=2 and cright=0) then
        if linlog=0 then 
            linlog=1
        else
            linlog=0
        end if
        ef=1 :newcal=1 :p=0        
        menu()
        dessin1()
        markers()
        dessin2()
        cright=1 :z10=0
    end if
    if bouton=0 then
        cleft=0 :cright=0
    end if
end if
if z11=1 then                     'change measure/scan
    if bouton=1 and cleft=0 then
'        nbsamp=2*nbsamp+1 :if nbsamp=1791 then nbsamp=6 '895
        nb=2*nb-1 :if nb=1601 then nb=51
        curseur1=cursor1*(nb-1)/largeur
        curseur2=cursor2*(nb-1)/largeur
        ef=1 :newcal=1 :p=0 :pmax=0 :cal=0
        menu()
        dessin1()
        markers()
        dessin2()
        cleft=1 :z11=0 ':refresh=1
    end if
    if bouton=2 and cright=0 then
'       nbsamp=(nbsamp+1)/2-1 :if nbsamp<5 then nbsamp=895 '6
        nb=(nb+1)/2 :if nb=26 then nb=801
        curseur1=cursor1*(nb-1)/largeur
        curseur2=cursor2*(nb-1)/largeur        
        ef=1 :newcal=1 :p=0 :pmax=0 :cal=0
        menu()
        dessin1()
        markers()
        dessin2()       
        cright=1 :z11=0 ':refresh=1
    end if    
    if bouton=0 then
        cleft=0 :cright=0
    end if
'    if wheel>roue11 then
'        nbsamp=2*nbsamp+1 :if nbsamp=1791 then nbsamp=6
'        nb=2*nb-1 :if nb=1601 then nb=51        
'        z11=0 :refresh=1 :sleep 100 :roue12=wheel
'    end if
'    if wheel<roue12 then
'        nbsamp=(nbsamp+1)/2-1 :if nbsamp<5 then nbsamp=895
'        z12=0 :refresh=1 :sleep 100 :roue12=wheel
'    end if
'else
'    roue12=wheel
end if
if z12=1 then                     'change ms/measure
    if bouton=1 and cleft=0 then
        nbsamp=2*nbsamp+1 :if nbsamp=1791 then nbsamp=6 '895
        cleft=1 :z12=0 :refresh=1
    end if
    if bouton=2 and cright=0 then
       nbsamp=(nbsamp+1)/2-1 :if nbsamp<5 then nbsamp=895 '6
       cright=1 :z12=0 :refresh=1
    end if    
    if bouton=0 then
        cleft=0 :cright=0
    end if
    if wheel>roue12 then
        nbsamp=2*nbsamp+1 :if nbsamp=1791 then nbsamp=6
        z12=0 :refresh=1 :sleep 100 :roue12=wheel
    end if
    if wheel<roue12 then
        nbsamp=(nbsamp+1)/2-1 :if nbsamp<5 then nbsamp=895
        z12=0 :refresh=1 :sleep 100 :roue12=wheel
    end if
else
    roue12=wheel
end if
if z13=1 then                     'change delay aperture
    if bouton=1 and cleft=0 then
        ap=2*ap :if ap=128*(nb-1)/400 then ap=2
        cleft=1 :z13=0 :refresh=1
    end if
    if bouton=2 and cright=0 then
        ap=ap/2 :if ap=1 then ap=64*(nb-1)/400
        cright=1 :z13=0 :refresh=1
    end if    
    if bouton=0 then
        cleft=0 :cright=0
    end if
end if
if z14=1 then   'pour editer length(m)                      
    if (bouton=1 and cleft=0) then
        locate 24,rep+12 :color 0,14
        print "_            "
        color 15,0
        z14sub()
        if sort=1 then goto sortie
        cleft=1 :z14=0 :refresh=1
    end if
    if bouton=0 then cleft=0
    if wheel<roue14 or wheel>roue14 then
        kz=0
        if x<(rep+21)*8 then kz=0.0001
        if x<(rep+20)*8 then kz=0.001
        if x<(rep+19)*8 then kz=0.01
        if x<(rep+18)*8 then kz=0.1
        if x<(rep+16)*8 then kz=1
        if x<(rep+15)*8 then kz=10
        if x<(rep+14)*8 then kz=100
        if x<(rep+17)*8 and x>=(rep+16)*8 then k=0
        if wheel<roue14 then kz=-kz
        if lon+kz<999 and lon+kz>-999 then lon=lon+kz
        sleep 100
        z14=0 :refresh=1 :roue14=wheel
    end if
else
    roue14=wheel
end if
if z15=1 then 'pour normalize
    if (bouton=1 and cleft=0) then
        if cal=0 then
            locate 25,rep+12 :color 0,15
            print " asked       "
            locate 20,20 :color 0,15
            print " Replace the device under test with a     "
            locate 21,20
            print " through connection, then start normalize "
            locate 36,rep+2 :color 15,0
            print " Start normalize"
            cal=1
        else
            if cal>0 then
                cal=0
            end if
        end if
        menu() :dessin1()
        calcul() :markers() :dessin2()
        cleft=1 :z15=0 ':refresh=1
    end if
    if bouton=0 then cleft=0
end if

if z16=1 then
    if bouton=1 and cleft=0 then
        dis=dis+1
        if ti=0 and dis=5 then dis=0
        if ti>0 and dis=4 then dis=0
        if ti=0 and M1M2=0 and (dis=3 or dis=2) then dis=4
        cleft=1 :z16=0 :refresh=1
    end if
    if bouton=2 and cright=0 then
       dis=dis-1 
       if ti=0 and dis=-1 then dis=4
       if ti>0 and dis=-1 then dis=3
       cright=1 :z16=0 :refresh=1
    end if    
    if bouton=0 then cleft=0 :cright=0
end if
if z17=1 then
    if bouton=1 and cleft=0 then
        if complet=1 then
            for i=0 to nb-1
                M1(i)=w33(i)
                M2(i)=z33(i)
            next i
            m1m2=1
            locate 28,rep+3 :color 0,14
            print "    Measure copied    "
            sleep 1200
            locate 28,rep+3 
            print "Copy Measure to Memory"
            color 15,0
        else
            locate 31,rep+2 :color 0,6
            print " error : aquisition "
            locate 32,rep+2
            print " not completed      "
            color 15,0
        end if
        cleft=1 :z17=0
    end if
    if bouton=0 then cleft=0
end if
if z18=1 then
    if bouton=1 and cleft=0 then
        if complet=1 then
            savefile() 
            menu() :dessin1() :markers :dessin2() :verif
            if bmpecri=1 then
                bmpecri=0 :ecribmp()
            end if
        else
            locate 31,rep+2 :color 0,6
            print " error : aquisition "
            locate 32,rep+2
            print " not completed      "
            color 15,0
        end if
        cleft=1 :z18=0
    end if
    if bouton=0 then cleft=0
end if


if z22=1 then 'bouton start
    if erreur1=0 and erreur2=0 and erreur3=0 and erreur4=0 and erreur5=0 then
        if bouton=1 and cleft=0 then
            if cal=1 then
                cal=2 
                p=0 :pmax=0 :ef=0 :complet=0 :m1m2=0
            end if
            if ef=1 then 
                p=0 :pmax=0 :ef=0 :complet=0 :m1m2=0 :newcal=1
            end if
            va=1
            p=pmax
            menu()
            dessin1()
            markers()
            dessin2()
            cleft=1 :z22=0 :zq22=0
            goto parici
        end if
    end if
    if bouton=0 then cleft=0
end if
if z23=1 then                     'to display the help message
    if bouton=1 and cleft=0 then
        help()
        menu() :dessin1()
        markers() :dessin2() :verif()
        cleft=1 :z23=0 ':refresh=1
    end if
    if bouton=2 and cright=0 then
        help()
        menu() :dessin1()
        markers() :dessin2() :verif()
        cright=1 :z23=0 ':refresh=1
    end if    
    if bouton=0 then
        cleft=0 :cright=0
    end if
end if
if z24=1 then  'to adjust A/R gain & phase and set the clock frequency 
    if bouton=1 and cleft=0 then
        adjust()
        menu() :dessin1()
        markers() :dessin2() :verif()
        cleft=1 :z24=0 ':refresh=1
    end if
    if bouton=2 and cright=0 then
        adjust()
        menu() :dessin1()
        markers() :dessin2() :verif()
        cright=1 :z24=0 ':refresh=1
    end if    
    if bouton=0 then
        cleft=0 :cright=0
    end if
end if
if z25=1 then 'pour sortir
    if bouton=1 and cleft=0 then
        goto sortie
    end if
    if bouton=2 and cright=0 then
        goto sortie
    end if
    if bouton=0 then
        cleft=0 :cright=0
    end if
    
end if

'pour deplacer les curseurs sur la courbe

if x>bor+cursor1-7 and x<bor+cursor1+7 and y>bor-1 and y<bor+hauteur+1 and cur2=0 then
    if cur1=0 and cur2=0 then
        cur1=1
    end if
else
    if cur1=1 and bouton=0 then
        cur1=0
    end if
end if
if cur1=1 and bouton=1 and x<>bor+cursor1 and x<bor+largeur+1 and x>bor-1 then
    xx=x
    if xx>bor+largeur then xx=bor+largeur
    if xx<bor then xx=bor
    cursor1=xx-bor
    curseur1=cursor1*(nb-1)/largeur
    screencopy 2,1
    markers()
    dessin2()
end if

if x>bor+cursor2-7 and x<bor+cursor2+7 and y>bor-1 and y<bor+hauteur+1 and cur1=0 then
    if cur1=0 and cur2=0 then
        cur2=1
    end if
else
    if cur2=1 and bouton=0 then
        cur2=0
    end if
end if
if cur2=1 and bouton=1 and x<>bor+cursor2 and x<bor+largeur+1 and x>bor-1 then
    xx=x
    if xx>bor+largeur then xx=bor+largeur
    if xx<bor then xx=bor
    cursor2=xx-bor
    curseur2=cursor2*(nb-1)/largeur
    screencopy 2,1
    markers()
    dessin2()
end if


'pour deplacer le pointeur dans les menus
repl=(rep+1)*8
if x>(rep+1)*8 and x<(rep+1)*8+200 and y>=0 and  y<48   then  'main choice
    if z1=0 then
        color 0,14
        if ti=0 then
            locate 1,rep+2
            print "gain & phase vs frequency"
            locate 2,rep+2
            print "    gain: dB scale       "
            locate 3,rep+2
            print "      dB & degres        "
        end if
        if ti=1 then
            locate 1,rep+2
            print "gain & phase vs frequency"
            locate 2,rep+2
            print "gain: linear scale (Unit)"
            locate 3,rep+2
            print "      U & degres         "
        end if
        if ti=2 then
            locate 1,rep+2
            print "gain & delay vs frequency"
            locate 2,rep+2
            print "    gain: dB scale       "
            locate 3,rep+2
            print "      dB & us            "
        end if
        z1=1
        color 15,0
    end if
else
    if z1=1 then
        color 14,0
        if ti=0 then
            locate 1,rep+2
            print "gain & phase vs frequency"
            locate 2,rep+2
            print "    gain: dB scale       "
            locate 3,rep+2
            print "      dB & degres        "
        end if
        if ti=1 then
            locate 1,rep+2
            print "gain & phase vs frequency"
            locate 2,rep+2
            print "gain: linear scale (Unit)"
            locate 3,rep+2
            print "      U & degres         "
        end if
        if ti=2 then
            locate 1,rep+2
            print "gain & delay vs frequency"
            locate 2,rep+2
            print "    gain: dB scale       "
            locate 3,rep+2
            print "      dB & us            "
        end if        
        z1=0
        color 15,0
    end if
end if

if x>repl and x<repl+200 and y>79 and  y<96   then  'gain max
    if z2=0 then
        locate 6,rep+12 :color 0,15
        print using "#######.#####";maax(ti)
        z2=1
        color 15,0
    end if
else
    if z2=1 then
        locate 6,rep+12 :color 15,0
        print using "#######.#####";maax(ti)
        z2=0
    end if
end if

if x>repl and x<repl+200 and y>95 and  y<112   then  'gain min
    if z3=0 then
        locate 7,rep+12 :color 0,15
        print using "#######.#####";miin(ti)
        z3=1
        color 15,0
    end if
else
    if z3=1 then
        locate 7,rep+12 :color 15,0
        print using "#######.#####";miin(ti)       
        z3=0
    end if
end if

if x>repl and x<repl+200 and y>143 and  y<160   then  'phase/delay max
    if z4=0 then
        locate 10,rep+12 :color 0,15
        print using "#######.#####";maxa(ti)
        z4=1
        color 15,0
    end if
else
    if z4=1 then
        locate 10,rep+12 :color 15,0
        print using "#######.#####";maxa(ti)
        z4=0
    end if
end if

if x>repl and x<repl+200 and y>159 and  y<176   then  'phase/delay min
    if z5=0 then
        locate 11,rep+12 :color 0,15
        print using "#######.#####";mina(ti)
        z5=1
        color 15,0
    end if
else
    if z5=1 then
        locate 11,rep+12 :color 15,0
        print using "#######.#####";mina(ti)
        z5=0
    end if
end if

if x>repl and x<repl+200 and y>207 and  y<224   then  'frequency max
    if z6=0 then
        locate 14,rep+12 :color 0,15
        print using "##########.##";fstop
        z6=1
        color 15,0
    end if
else
    if z6=1 then
        locate 14,rep+12 :color 15,0
        print using "##########.##";fstop
        z6=0
    end if
end if

if x>repl and x<repl+200 and y>223 and  y<240   then  'frequency min
    if z7=0 then
        locate 15,rep+12 :color 0,15
        print using "##########.##";fstart
        z7=1
        color 15,0
    end if
else
    if z7=1 then
        locate 15,rep+12 :color 15,0
        print using "##########.##";fstart
        z7=0
    end if
end if
if linlog=0 then
    if x>repl and x<repl+200 and y>255 and  y<272   then  'center frequency
        if z8=0 then
            locate 17,rep+12 :color 0,15
            print using "##########.##";center
            z8=1
            color 15,0
        end if
    else
        if z8=1 then
            locate 17,rep+12 :color 15,0
            print using "##########.##";center
            z8=0
        end if
    end if
    if x>repl and x<repl+200 and y>271 and  y<288   then  'span
        if z9=0 then
            locate 18,rep+12 :color 0,15
            print using "##########.##";span
            z9=1
            color 15,0
        end if
    else
        if z9=1 then
            locate 18,rep+12 :color 15,0
            print using "##########.##";span
            z9=0
        end if
    end if    
end if
if x>repl and x<repl+200 and y>303 and  y<320   then  'sweep lin/log
    if z10=0 then
        locate 20,rep+12 :color 0,15
        if linlog=0 then print " linear      "
        if linlog=1 then print " log         "
        z10=1
        color 15,0
    end if
else
    if z10=1 then
        locate 20,rep+12 :color 15,0
        if linlog=0 then print " linear      "
        if linlog=1 then print " log         "        
        z10=0
    end if
end if
if x>repl and x<repl+200 and y>319 and  y<336   then  'measures/scan
    if z11=0 then
        locate 21,rep+13 :color 0,15
        print "            "
        locate 21,rep+12
        print nb
        z11=1
        color 15,0
    end if
else
    if z11=1 then
        locate 21,rep+13 :color 15,0
        print "            "
        locate 21,rep+12
        print nb      
        z11=0
    end if
end if
if x>repl and x<repl+200 and y>335 and  y<352   then  'ms/measure
    if z12=0 then
        locate 22,rep+13 :color 0,15
        print "            "
        locate 22,rep+12
        print 40*(nbsamp+1)/7
        z12=1
        color 15,0
    end if
else
    if z12=1 then
        locate 22,rep+13 :color 15,0
        print "            "
        locate 22,rep+12
        print 40*(nbsamp+1)/7    
        z12=0
    end if
end if
if ti=2 then
    if x>repl and x<repl+200 and y>351 and  y<368   then  'delay aperture
        if z13=0 then
            locate 23,rep+13 :color 0,15
            print "            "
            locate 23,rep+12
            print (ap/4)*400/(nb-1);"%"
            z13=1
            color 15,0
        end if
    else
        if z13=1 then
            locate 23,rep+13 :color 15,0
            print "            "
            locate 23,rep+12
            print (ap/4)*400/(nb-1);"%"   
            z13=0
        end if
    end if
end if
if cal=0 then
    if x>repl and x<repl+200 and y>367 and  y<384   then  'length
        if z14=0 then
            locate 24,rep+12 :color 0,15
            print "            "
            locate 24,rep+13 :print using "####.####";lon

            z14=1
            color 15,0
        end if
    else
        if z14=1 then
            locate 24,rep+12 :color 15,0
            print "            "
            locate 24,rep+13 :print using "####.####";lon
            z14=0
        end if
    end if
end if
if x>repl and x<repl+200 and y>383 and  y<400   then  'normalize
    if z15=0 then
        locate 25,rep+12 :color 0,15
        if cal=0 then print " off         "
        if cal=1 then print " asked       "
        if cal=2 then print " running     "
        if cal=3 then print " on          "
        if cal=4 then print " warning     "
        z15=1
        color 15,0
    end if
else
    if z15=1 then
        locate 25,rep+12 :color 15,0
        if cal=0 then print " off         "
        if cal=1 then print " asked       "
        if cal=2 then print " running     "
        if cal=3 then print " on          "
        if cal=4 then print " warning     "        
        z15=0
    end if
end if
if x>repl and x<repl+200 and y>399 and  y<416   then  'display
    if z16=0 then
        locate 26,rep+12 :color 0,15
        if ti=1 then
            if dis=4 then dis=0
            if dis=2 and M1M2=0 then dis=0
            if dis=3 and M1M2=0 then dis=1
            if dis=0 then print " U,deg       "
            if dis=1 then print " U           "
            if dis=2 then print " U,deg, + Mem"
            if dis=3 then print " U + Mem     "
        end if
        if ti=2 then
            if dis=4 then dis=0
            if dis=2 and M1M2=0 then dis=0
            if dis=3 and M1M2=0 then dis=1
            if dis=0 then print " dB,us       "
            if dis=1 then print " dB          "
            if dis=2 then print " dB,us, + Mem"
            if dis=3 then print " dB + Mem    "
        end if
        if ti=0 then
            if dis=2 and M1M2=0 then dis=0
            if dis=3 and M1M2=0 then dis=1
            if dis=0 then print " dB,deg      "
            if dis=1 then print " dB          "
            if dis=2 then print " dB,deg,+ Mem"
            if dis=3 then print " dB + Mem    "
            if dis=4 then print " dB,A,R      "
        end if
        z16=1
        color 15,0
    end if
else
    if z16=1 then
        locate 26,rep+12 :color 15,0
        if ti=1 then
            if dis=4 then dis=0
            if dis=2 and M1M2=0 then dis=0
            if dis=3 and M1M2=0 then dis=1
            if dis=0 then print " U,deg       "
            if dis=1 then print " U           "
            if dis=2 then print " U,deg, + Mem"
            if dis=3 then print " U + Mem     "
        end if
        if ti=2 then
            if dis=4 then dis=0
            if dis=2 and M1M2=0 then dis=0
            if dis=3 and M1M2=0 then dis=1
            if dis=0 then print " dB,us       "
            if dis=1 then print " dB          "
            if dis=2 then print " dB,us, + Mem"
            if dis=3 then print " dB + Mem    "
        end if
        if ti=0 then
            if dis=2 and M1M2=0 then dis=0
            if dis=3 and M1M2=0 then dis=1
            if dis=0 then print " dB,deg      "
            if dis=1 then print " dB          "
            if dis=2 then print " dB,deg,+ Mem"
            if dis=3 then print " dB + Mem    "
            if dis=4 then print " dB,A,R      "
            if dis=4 then
                locate 26,rep+16 :color 3 :print "A"
                locate 26,rep+18 :color 13 :print "R" : color 15
            end if
        end if
        z16=0
    end if
end if
if x>(rep+2)*8 and x<(rep+25)*8 and y>431 and  y<448   then  'copy to
    if z17=0 then
        locate 28,rep+3 :color 0,15
        print "Copy Measure to Memory"
        z17=1
        color 15,0
    end if
else
    if z17=1 then
        locate 28,rep+3 :color 15,0
        print "Copy Measure to Memory"
        z17=0
    end if
end if
if x>(rep+2)*8 and x<(rep+25)*8 and y>447 and  y<464   then  'copy to
    if z18=0 then
        locate 29,rep+3 :color 0,15
        print "Save Measure to File  "
        z18=1
        color 15,0
    end if
else
    if z18=1 then
        locate 29,rep+3 :color 15,0
        print "Save Measure to File  "
        z18=0
    end if
end if
if x>(rep+2)*8 and x<(rep+20)*8 and y>431+16*8 and y<448+16*8 then
    if z22=0 then
        locate 36,rep+2 :color 0,15
        if va=1 and (cal<1 or cal>2) then print " Stop           "
        if va=0 and cal=1 then print " Start normalize"
        if va=1 and cal=2 then print " Abort normalize"
        if va=0 and (cal<1 or cal>2) then print " Start          "
        z22=1 :color 15,0
    end if
else
    if z22=1 then
        locate 36,rep+2 :color 15,0
        if va=1 and (cal<1 or cal>2) then print " Stop           "
        if va=0 and cal=1 then print " Start normalize"
        if va=1 and cal=2 then print " Abort normalize"
        if va=0 and (cal<1 or cal>2) then print " Start          "        
        z22=0
    end if
end if
if x>(rep+2)*8 and x<(rep+20)*8 and y>431+16*10 and y<448+16*10 then
    if z23=0 then
        locate 38,rep+2 :color 0,15
        print " Help           "
        z23=1 :color 15,0
    end if
else
    if z23=1 then
        locate 38,rep+2 :color 15,0
        print " Help           "
        z23=0
    end if
end if
if x>(rep+2)*8 and x<(rep+20)*8 and y>431+16*12 and y<448+16*12 then
    if z24=0 then
        locate 40,rep+2 :color 0,15
        print " Adjustment     "
        z24=1 :color 15,0
    end if
else
    if z24=1 then
        locate 40,rep+2 :color 15,0
        print " Adjustment     "
        z24=0
    end if
end if
if x>(rep+2)*8 and x<(rep+20)*8 and y>431+16*14 and y<448+16*14 then
    if z25=0 then
        locate 42,rep+2 :color 0,15
        print " Exit           "
        z25=1 :color 15,0
    end if
else
    if z25=1 then
        locate 42,rep+2 :color 15,0
        print " Exit           "
        z25=0
    end if
end if


zut:
if refresh=1 and va=0 and erreur1=0 and erreur2=0 and erreur3=0 and erreur4=0 and erreur5=0 then 'and newcal=0 then
    for p=0 to nb-1
        calcul()
    next p
    menu()
    dessin1()
    markers()
    dessin2()
    resetz()
    p=0 :refresh=0
end if

l=inkey$
sleep 10
if l="" then goto boucle

if l=" " and erreur1=0 and erreur2=0 and erreur3=0 and erreur4=0 and erreur5=0 and (cal<1 or cal>2) then
    if cal=1 then
        cal=2 
        p=0 :pmax=0 :ef=0 :complet=0 :m1m2=0
    end if
    if ef=1 then 
        p=0 :pmax=0 :ef=0 :complet=0 :m1m2=0 :newcal=1
    end if
    va=1 :zq22=0
    p=pmax
    menu() :dessin1()
    markers()
    dessin2()
    goto parici
end if
if asc(l)=27 then goto sortie
l=left$(l,1)
if asc(l)>44 and asc(l)<58 and not(asc(l)=47) then
    if (z2=1 or z3=1) then num=1 :z2sub() :verif()  :refresh=1 :z2=0 :z3=0
    if (z4=1 or z5=1) then num=1  :z4sub() :verif() :refresh=1 :z4=0 :z5=0
    if z14=1 then num=1 :refresh=1 :z14sub() :verif() :z14=0
    if (z6=1 or z7=1 or z8=1 or z9=1) then
        num=1 :refresh=1 :z6sub() :verif() :z6=0 :z7=0 :z8=0 :z9=0
    end if
    
end if
if asc(l)=22 then  'utilisation de ctrl+V pour modifier les frequences
    if freq(curseur1)=freq(curseur2) then 'a modifier si on diminue nb
        center=freq(curseur1)
        complet=0 :m1m2=0 :p=0 :pmax=0  :ef=1 :cente=1
        if cal>2 then newcal=1 :cal=4
        verif() :menu() :dessin1() :markers() :dessin2() :resetz()
    else
        if freq(curseur1)<freq(curseur2) then
            fstart=freq(curseur1) :fstop=freq(curseur2)
        else
            fstart=freq(curseur2) :fstop=freq(curseur1)
        end if
        cente=0 :complet=0 :m1m2=0 :p=0 :pmax=0 :ef=1
        if cal>2 then newcal=1 :cal=4
        verif() :menu() :dessin1() :markers() :dessin2() :resetz()
    end if
end if
goto boucle

sortie:
close

end
